//////////////////////////////////////////////////////////////////////
////                                                              ////
////  OR1200's ALU definitions                                    ////
////                                                              ////
////  This file is part of the OpenRISC 1200 project              ////
////  http://www.opencores.org/cores/or1k/                        ////
////                                                              ////
////  Description                                                 ////
////  Parameters of ALU                                           ////
////                                                              ////
////  To Do:                                                      ////
////   - add additional parameters                                ////
////                                                              ////
////  Author(s):                                                  ////
////      - Damjan Lampret, lampret@opencores.org                 ////
////                                                              ////
//////////////////////////////////////////////////////////////////////
////                                                              ////
//// Copyright (C) 2000 Authors and OPENCORES.ORG                 ////
////                                                              ////
//// This source file may be used and distributed without         ////
//// restriction provided that this copyright statement is not    ////
//// removed from the file and that any derivative work contains  ////
//// the original copyright notice and the associated disclaimer. ////
////                                                              ////
//// This source file is free software; you can redistribute it   ////
//// and/or modify it under the terms of the GNU Lesser General   ////
//// Public License as published by the Free Software Foundation; ////
//// either version 2.1 of the License, or (at your option) any   ////
//// later version.                                               ////
////                                                              ////
//// This source is distributed in the hope that it will be       ////
//// useful, but WITHOUT ANY WARRANTY; without even the implied   ////
//// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR      ////
//// PURPOSE.  See the GNU Lesser General Public License for more ////
//// details.                                                     ////
////                                                              ////
//// You should have received a copy of the GNU Lesser General    ////
//// Public License along with this source; if not, download it   ////
//// from http://www.opencores.org/lgpl.shtml                     ////
////                                                              ////
//////////////////////////////////////////////////////////////////////
//
// CVS Revision History
//
// $Log$
//


`define ALUOP_NOP	4'd0

/* Order defined by arith insns that have two source operands both in regs
   (see binutils/include/opcode/or32.h) */
`define ALUOP_ADD	4'd0
`define ALUOP_ADDC	4'd1
`define ALUOP_SUB	4'd2
`define ALUOP_AND	4'd3
`define ALUOP_OR	4'd4
`define ALUOP_XOR	4'd5
`define ALUOP_MUL	4'd6
`define ALUOP_MAC	4'd7
`define ALUOP_SHROT	4'd8
`define ALUOP_DIV	4'd9
`define ALUOP_DIVU	4'd10

/* Order not specifically defined. */
`define ALUOP_IMM	4'd11
`define ALUOP_MOVHI	4'd12
`define ALUOP_COMP	4'd13
`define ALUOP_MTSR	4'd14
`define ALUOP_MFSR	4'd15

`define ALUOP_WIDTH	4

/* Shift/rotate macros. */
`define SHROTOP_NOP	2'd0
`define SHROTOP_SLL	2'd0
`define SHROTOP_SRL	2'd1
`define SHROTOP_SRA	2'd2
`define SHROTOP_ROR	2'd3

`define SHROTOP_WIDTH	2
