//////////////////////////////////////////////////////////////////////
////                                                              ////
////  OR1200's ITLB RAM                                           ////
////                                                              ////
////  This file is part of the OpenRISC 1200 project              ////
////  http://www.opencores.org/cores/or1k/                        ////
////                                                              ////
////  Description                                                 ////
////  ITLB RAM instatiation.                                      ////
////                                                              ////
////  To Do:                                                      ////
////   - make it smaller and faster                               ////
////                                                              ////
////  Author(s):                                                  ////
////      - Damjan Lampret, lampret@opencores.org                 ////
////                                                              ////
//////////////////////////////////////////////////////////////////////
////                                                              ////
//// Copyright (C) 2000 Authors and OPENCORES.ORG                 ////
////                                                              ////
//// This source file may be used and distributed without         ////
//// restriction provided that this copyright statement is not    ////
//// removed from the file and that any derivative work contains  ////
//// the original copyright notice and the associated disclaimer. ////
////                                                              ////
//// This source file is free software; you can redistribute it   ////
//// and/or modify it under the terms of the GNU Lesser General   ////
//// Public License as published by the Free Software Foundation; ////
//// either version 2.1 of the License, or (at your option) any   ////
//// later version.                                               ////
////                                                              ////
//// This source is distributed in the hope that it will be       ////
//// useful, but WITHOUT ANY WARRANTY; without even the implied   ////
//// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR      ////
//// PURPOSE.  See the GNU Lesser General Public License for more ////
//// details.                                                     ////
////                                                              ////
//// You should have received a copy of the GNU Lesser General    ////
//// Public License along with this source; if not, download it   ////
//// from http://www.opencores.org/lgpl.shtml                     ////
////                                                              ////
//////////////////////////////////////////////////////////////////////
//
// CVS Revision History
//
// $Log$
//

`include "general.h"

module itlbram(clk, addrw, datain, we, addra, dataout);

parameter dw = `PAGEINDX_WIDTH;
parameter aw = `ITLBADDR_WIDTH;

input [dw-1:0] datain;
output [dw-1:0] dataout;
output [dw-1:0] datab;

input [aw-1:0] addrw;
input [aw-1:0] addra;
input [aw-1:0] addrb;

input clk, we;

wire  high, low;

assign high = 1;
assign low = 0;

rf_128x13 itlbram(
   .QA(dataout),
   .OENSQA(high),
//   .ASQA
//   .TQA,
//   .QSQA,
//   .DSOB,
//   .CENSQB(high),
//   .ASQB,
   .CLKA(clk),
   .CENA(low),
   .OENA(low),
   .AA(addra),
   .TISA(low),
   .TMSA(low),
   .TCENA(low),  //normally high
   .TOENA(high),
   .TQOENA(high),
   .TAA(addra),
   .CLKB(clk),
   .CENB(~we),
   .AB(addrw),
   .DB(datain),
   .TISB(low),
   .TMSB(low),
   .TCENB(high),
   .TAB(addrw),
   .TDB(datain),
   .SMSB(low),
   .DSIB(low)
);

endmodule
