//////////////////////////////////////////////////////////////////////
////                                                              ////
////  OR1200's multiply                                           ////
////                                                              ////
////  This file is part of the OpenRISC 1200 project              ////
////  http://www.opencores.org/cores/or1k/                        ////
////                                                              ////
////  Description                                                 ////
////  Multiply unit                                               ////
////                                                              ////
////  To Do:                                                      ////
////   - make it smaller and faster                               ////
////                                                              ////
////  Author(s):                                                  ////
////      - Damjan Lampret, lampret@opencores.org                 ////
////                                                              ////
//////////////////////////////////////////////////////////////////////
////                                                              ////
//// Copyright (C) 2000 Authors and OPENCORES.ORG                 ////
////                                                              ////
//// This source file may be used and distributed without         ////
//// restriction provided that this copyright statement is not    ////
//// removed from the file and that any derivative work contains  ////
//// the original copyright notice and the associated disclaimer. ////
////                                                              ////
//// This source file is free software; you can redistribute it   ////
//// and/or modify it under the terms of the GNU Lesser General   ////
//// Public License as published by the Free Software Foundation; ////
//// either version 2.1 of the License, or (at your option) any   ////
//// later version.                                               ////
////                                                              ////
//// This source is distributed in the hope that it will be       ////
//// useful, but WITHOUT ANY WARRANTY; without even the implied   ////
//// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR      ////
//// PURPOSE.  See the GNU Lesser General Public License for more ////
//// details.                                                     ////
////                                                              ////
//// You should have received a copy of the GNU Lesser General    ////
//// Public License along with this source; if not, download it   ////
//// from http://www.opencores.org/lgpl.shtml                     ////
////                                                              ////
//////////////////////////////////////////////////////////////////////
//
// CVS Revision History
//
// $Log$
//

module MULT ( X, Y, CLK, CLR, P );
input  [15:0] X;
input  [15:0] Y;
input  CLK;
input  CLR;
output [47:0] P;
   wire [0:16] A;
   wire [0:15] B;
   wire [0:63] Q;
   MULTIPLIER_17_16 U1 (A , B , CLK , CLK , CLR , Q );
   assign A[0] = X[0];
   assign A[1] = X[1];
   assign A[2] = X[2];
   assign A[3] = X[3];
   assign A[4] = X[4];
   assign A[5] = X[5];
   assign A[6] = X[6];
   assign A[7] = X[7];
   assign A[8] = X[8];
   assign A[9] = X[9];
   assign A[10] = X[10];
   assign A[11] = X[11];
   assign A[12] = X[12];
   assign A[13] = X[13];
   assign A[14] = X[14];
   assign A[15] = X[15];
   assign A[16] = X[15];
   assign B[0] = Y[0];
   assign B[1] = Y[1];
   assign B[2] = Y[2];
   assign B[3] = Y[3];
   assign B[4] = Y[4];
   assign B[5] = Y[5];
   assign B[6] = Y[6];
   assign B[7] = Y[7];
   assign B[8] = Y[8];
   assign B[9] = Y[9];
   assign B[10] = Y[10];
   assign B[11] = Y[11];
   assign B[12] = Y[12];
   assign B[13] = Y[13];
   assign B[14] = Y[14];
   assign B[15] = Y[15];
   assign P[0] = Q[0];
   assign P[1] = Q[1];
   assign P[2] = Q[2];
   assign P[3] = Q[3];
   assign P[4] = Q[4];
   assign P[5] = Q[5];
   assign P[6] = Q[6];
   assign P[7] = Q[7];
   assign P[8] = Q[8];
   assign P[9] = Q[9];
   assign P[10] = Q[10];
   assign P[11] = Q[11];
   assign P[12] = Q[12];
   assign P[13] = Q[13];
   assign P[14] = Q[14];
   assign P[15] = Q[15];
   assign P[16] = Q[16];
   assign P[17] = Q[17];
   assign P[18] = Q[18];
   assign P[19] = Q[19];
   assign P[20] = Q[20];
   assign P[21] = Q[21];
   assign P[22] = Q[22];
   assign P[23] = Q[23];
   assign P[24] = Q[24];
   assign P[25] = Q[25];
   assign P[26] = Q[26];
   assign P[27] = Q[27];
   assign P[28] = Q[28];
   assign P[29] = Q[29];
   assign P[30] = Q[30];
   assign P[31] = Q[31];
   assign P[32] = Q[32];
   assign P[33] = Q[33];
   assign P[34] = Q[34];
   assign P[35] = Q[35];
   assign P[36] = Q[36];
   assign P[37] = Q[37];
   assign P[38] = Q[38];
   assign P[39] = Q[39];
   assign P[40] = Q[40];
   assign P[41] = Q[41];
   assign P[42] = Q[42];
   assign P[43] = Q[43];
   assign P[44] = Q[44];
   assign P[45] = Q[45];
   assign P[46] = Q[46];
   assign P[47] = Q[47];
endmodule


module PP_LOW ( ONEPOS, ONENEG, TWONEG, INA, INB, PPBIT );
input  ONEPOS;
input  ONENEG;
input  TWONEG;
input  INA;
input  INB;
output PPBIT;
   assign PPBIT = (ONEPOS & INA) | (ONENEG & INB) | TWONEG;
endmodule


module PP_MIDDLE ( ONEPOS, ONENEG, TWOPOS, TWONEG, INA, INB, INC, IND, PPBIT );
input  ONEPOS;
input  ONENEG;
input  TWOPOS;
input  TWONEG;
input  INA;
input  INB;
input  INC;
input  IND;
output PPBIT;
   assign PPBIT =  ~ (( ~ (INA & TWOPOS)) & ( ~ (INB & TWONEG)) & ( ~ (INC & ONEPOS)) & ( ~ (IND & ONENEG)));
endmodule


module PP_HIGH ( ONEPOS, ONENEG, TWOPOS, TWONEG, INA, INB, PPBIT );
input  ONEPOS;
input  ONENEG;
input  TWOPOS;
input  TWONEG;
input  INA;
input  INB;
output PPBIT;
   assign PPBIT =  ~ ((INA & ONEPOS) | (INB & ONENEG) | (INA & TWOPOS) | (INB & TWONEG));
endmodule


module R_GATE ( INA, INB, INC, PPBIT );
input  INA;
input  INB;
input  INC;
output PPBIT;
   assign PPBIT = ( ~ (INA & INB)) & INC;
endmodule


module DECODER ( INA, INB, INC, TWOPOS, TWONEG, ONEPOS, ONENEG );
input  INA;
input  INB;
input  INC;
output TWOPOS;
output TWONEG;
output ONEPOS;
output ONENEG;
   assign TWOPOS =  ~ ( ~ (INA & INB & ( ~ INC)));
   assign TWONEG =  ~ ( ~ (( ~ INA) & ( ~ INB) & INC));
   assign ONEPOS = (( ~ INA) & INB & ( ~ INC)) | (( ~ INC) & ( ~ INB) & INA);
   assign ONENEG = (INA & ( ~ INB) & INC) | (INC & INB & ( ~ INA));
endmodule


module BOOTH_INBUF ( CLK, OPA_IN, OPB_IN, OPA_OUT, OPB_OUT );
input  CLK;
input  [0:16] OPA_IN;
input  [0:15] OPB_IN;
output [0:16] OPA_OUT;
output [0:15] OPB_OUT;
   reg [0:16] OPA_OUT_reg;
   reg [0:15] OPB_OUT_reg;
   always @ ( posedge CLK ) begin
      OPA_OUT_reg[0:16] = OPA_IN[0:16];
      OPB_OUT_reg[0:15] = OPB_IN[0:15];
   end
   assign OPA_OUT[0:16] = OPA_OUT_reg[0:16];
   assign OPB_OUT[0:15] = OPB_OUT_reg[0:15];
endmodule


module BOOTHCODER_17_16 ( OPA, OPB, CLK, SUMMAND );
input  [0:16] OPA;
input  [0:15] OPB;
input  CLK;
output [0:159] SUMMAND;
   wire [0:16] INV_MULTIPLICAND;
   wire [0:31] INT_MULTIPLIER;
   wire [0:16] INT_OPA;
   wire [0:15] INT_OPB;
   wire LOGIC_ONE, LOGIC_ZERO;
   assign LOGIC_ONE = 1;
   assign LOGIC_ZERO = 0;
   BOOTH_INBUF S_IN (CLK , OPA , OPB , INT_OPA , INT_OPB
 );
   DECODER DEC_0 (.INA (LOGIC_ZERO) , .INB (INT_OPB[0]) , .INC (INT_OPB[1]) , .TWOPOS (INT_MULTIPLIER[0]) , .TWONEG (INT_MULTIPLIER[1]) , .ONEPOS (INT_MULTIPLIER[2]) , .ONENEG (INT_MULTIPLIER[3]) );
   assign INV_MULTIPLICAND[0] =  ~ INT_OPA[0];
   PP_LOW PPL_0 (.INA (INT_OPA[0]) , .INB (INV_MULTIPLICAND[0]) , .TWONEG (INT_MULTIPLIER[1]) , .ONEPOS (INT_MULTIPLIER[2]) , .ONENEG (INT_MULTIPLIER[3]) , .PPBIT (SUMMAND[0]) );
   R_GATE RGATE_0 (.INA (LOGIC_ZERO) , .INB (INT_OPB[0]) , .INC (INT_OPB[1]) , .PPBIT (SUMMAND[1]) );
   assign INV_MULTIPLICAND[1] =  ~ INT_OPA[1];
   PP_MIDDLE PPM_0 (.INA (INT_OPA[0]) , .INB (INV_MULTIPLICAND[0]) , .INC (INT_OPA[1]) , .IND (INV_MULTIPLICAND[1]) , .TWOPOS (INT_MULTIPLIER[0]) , .TWONEG (INT_MULTIPLIER[1]) , .ONEPOS (INT_MULTIPLIER[2]) , .ONENEG (INT_MULTIPLIER[3]) , .PPBIT (SUMMAND[2]) );
   assign INV_MULTIPLICAND[2] =  ~ INT_OPA[2];
   PP_MIDDLE PPM_1 (.INA (INT_OPA[1]) , .INB (INV_MULTIPLICAND[1]) , .INC (INT_OPA[2]) , .IND (INV_MULTIPLICAND[2]) , .TWOPOS (INT_MULTIPLIER[0]) , .TWONEG (INT_MULTIPLIER[1]) , .ONEPOS (INT_MULTIPLIER[2]) , .ONENEG (INT_MULTIPLIER[3]) , .PPBIT (SUMMAND[3]) );
   assign INV_MULTIPLICAND[3] =  ~ INT_OPA[3];
   PP_MIDDLE PPM_2 (.INA (INT_OPA[2]) , .INB (INV_MULTIPLICAND[2]) , .INC (INT_OPA[3]) , .IND (INV_MULTIPLICAND[3]) , .TWOPOS (INT_MULTIPLIER[0]) , .TWONEG (INT_MULTIPLIER[1]) , .ONEPOS (INT_MULTIPLIER[2]) , .ONENEG (INT_MULTIPLIER[3]) , .PPBIT (SUMMAND[6]) );
   assign INV_MULTIPLICAND[4] =  ~ INT_OPA[4];
   PP_MIDDLE PPM_3 (.INA (INT_OPA[3]) , .INB (INV_MULTIPLICAND[3]) , .INC (INT_OPA[4]) , .IND (INV_MULTIPLICAND[4]) , .TWOPOS (INT_MULTIPLIER[0]) , .TWONEG (INT_MULTIPLIER[1]) , .ONEPOS (INT_MULTIPLIER[2]) , .ONENEG (INT_MULTIPLIER[3]) , .PPBIT (SUMMAND[8]) );
   assign INV_MULTIPLICAND[5] =  ~ INT_OPA[5];
   PP_MIDDLE PPM_4 (.INA (INT_OPA[4]) , .INB (INV_MULTIPLICAND[4]) , .INC (INT_OPA[5]) , .IND (INV_MULTIPLICAND[5]) , .TWOPOS (INT_MULTIPLIER[0]) , .TWONEG (INT_MULTIPLIER[1]) , .ONEPOS (INT_MULTIPLIER[2]) , .ONENEG (INT_MULTIPLIER[3]) , .PPBIT (SUMMAND[12]) );
   assign INV_MULTIPLICAND[6] =  ~ INT_OPA[6];
   PP_MIDDLE PPM_5 (.INA (INT_OPA[5]) , .INB (INV_MULTIPLICAND[5]) , .INC (INT_OPA[6]) , .IND (INV_MULTIPLICAND[6]) , .TWOPOS (INT_MULTIPLIER[0]) , .TWONEG (INT_MULTIPLIER[1]) , .ONEPOS (INT_MULTIPLIER[2]) , .ONENEG (INT_MULTIPLIER[3]) , .PPBIT (SUMMAND[15]) );
   assign INV_MULTIPLICAND[7] =  ~ INT_OPA[7];
   PP_MIDDLE PPM_6 (.INA (INT_OPA[6]) , .INB (INV_MULTIPLICAND[6]) , .INC (INT_OPA[7]) , .IND (INV_MULTIPLICAND[7]) , .TWOPOS (INT_MULTIPLIER[0]) , .TWONEG (INT_MULTIPLIER[1]) , .ONEPOS (INT_MULTIPLIER[2]) , .ONENEG (INT_MULTIPLIER[3]) , .PPBIT (SUMMAND[20]) );
   assign INV_MULTIPLICAND[8] =  ~ INT_OPA[8];
   PP_MIDDLE PPM_7 (.INA (INT_OPA[7]) , .INB (INV_MULTIPLICAND[7]) , .INC (INT_OPA[8]) , .IND (INV_MULTIPLICAND[8]) , .TWOPOS (INT_MULTIPLIER[0]) , .TWONEG (INT_MULTIPLIER[1]) , .ONEPOS (INT_MULTIPLIER[2]) , .ONENEG (INT_MULTIPLIER[3]) , .PPBIT (SUMMAND[24]) );
   assign INV_MULTIPLICAND[9] =  ~ INT_OPA[9];
   PP_MIDDLE PPM_8 (.INA (INT_OPA[8]) , .INB (INV_MULTIPLICAND[8]) , .INC (INT_OPA[9]) , .IND (INV_MULTIPLICAND[9]) , .TWOPOS (INT_MULTIPLIER[0]) , .TWONEG (INT_MULTIPLIER[1]) , .ONEPOS (INT_MULTIPLIER[2]) , .ONENEG (INT_MULTIPLIER[3]) , .PPBIT (SUMMAND[30]) );
   assign INV_MULTIPLICAND[10] =  ~ INT_OPA[10];
   PP_MIDDLE PPM_9 (.INA (INT_OPA[9]) , .INB (INV_MULTIPLICAND[9]) , .INC (INT_OPA[10]) , .IND (INV_MULTIPLICAND[10]) , .TWOPOS (INT_MULTIPLIER[0]) , .TWONEG (INT_MULTIPLIER[1]) , .ONEPOS (INT_MULTIPLIER[2]) , .ONENEG (INT_MULTIPLIER[3]) , .PPBIT (SUMMAND[35]) );
   assign INV_MULTIPLICAND[11] =  ~ INT_OPA[11];
   PP_MIDDLE PPM_10 (.INA (INT_OPA[10]) , .INB (INV_MULTIPLICAND[10]) , .INC (INT_OPA[11]) , .IND (INV_MULTIPLICAND[11]) , .TWOPOS (INT_MULTIPLIER[0]) , .TWONEG (INT_MULTIPLIER[1]) , .ONEPOS (INT_MULTIPLIER[2]) , .ONENEG (INT_MULTIPLIER[3]) , .PPBIT (SUMMAND[42]) );
   assign INV_MULTIPLICAND[12] =  ~ INT_OPA[12];
   PP_MIDDLE PPM_11 (.INA (INT_OPA[11]) , .INB (INV_MULTIPLICAND[11]) , .INC (INT_OPA[12]) , .IND (INV_MULTIPLICAND[12]) , .TWOPOS (INT_MULTIPLIER[0]) , .TWONEG (INT_MULTIPLIER[1]) , .ONEPOS (INT_MULTIPLIER[2]) , .ONENEG (INT_MULTIPLIER[3]) , .PPBIT (SUMMAND[48]) );
   assign INV_MULTIPLICAND[13] =  ~ INT_OPA[13];
   PP_MIDDLE PPM_12 (.INA (INT_OPA[12]) , .INB (INV_MULTIPLICAND[12]) , .INC (INT_OPA[13]) , .IND (INV_MULTIPLICAND[13]) , .TWOPOS (INT_MULTIPLIER[0]) , .TWONEG (INT_MULTIPLIER[1]) , .ONEPOS (INT_MULTIPLIER[2]) , .ONENEG (INT_MULTIPLIER[3]) , .PPBIT (SUMMAND[56]) );
   assign INV_MULTIPLICAND[14] =  ~ INT_OPA[14];
   PP_MIDDLE PPM_13 (.INA (INT_OPA[13]) , .INB (INV_MULTIPLICAND[13]) , .INC (INT_OPA[14]) , .IND (INV_MULTIPLICAND[14]) , .TWOPOS (INT_MULTIPLIER[0]) , .TWONEG (INT_MULTIPLIER[1]) , .ONEPOS (INT_MULTIPLIER[2]) , .ONENEG (INT_MULTIPLIER[3]) , .PPBIT (SUMMAND[63]) );
   assign INV_MULTIPLICAND[15] =  ~ INT_OPA[15];
   PP_MIDDLE PPM_14 (.INA (INT_OPA[14]) , .INB (INV_MULTIPLICAND[14]) , .INC (INT_OPA[15]) , .IND (INV_MULTIPLICAND[15]) , .TWOPOS (INT_MULTIPLIER[0]) , .TWONEG (INT_MULTIPLIER[1]) , .ONEPOS (INT_MULTIPLIER[2]) , .ONENEG (INT_MULTIPLIER[3]) , .PPBIT (SUMMAND[72]) );
   assign INV_MULTIPLICAND[16] =  ~ INT_OPA[16];
   PP_MIDDLE PPM_15 (.INA (INT_OPA[15]) , .INB (INV_MULTIPLICAND[15]) , .INC (INT_OPA[16]) , .IND (INV_MULTIPLICAND[16]) , .TWOPOS (INT_MULTIPLIER[0]) , .TWONEG (INT_MULTIPLIER[1]) , .ONEPOS (INT_MULTIPLIER[2]) , .ONENEG (INT_MULTIPLIER[3]) , .PPBIT (SUMMAND[80]) );
   PP_HIGH PPH_0 (.INA (INT_OPA[16]) , .INB (INV_MULTIPLICAND[16]) , .TWOPOS (INT_MULTIPLIER[0]) , .TWONEG (INT_MULTIPLIER[1]) , .ONEPOS (INT_MULTIPLIER[2]) , .ONENEG (INT_MULTIPLIER[3]) , .PPBIT (SUMMAND[88]) );
   assign SUMMAND[89] = 1;
   DECODER DEC_1 (.INA (INT_OPB[1]) , .INB (INT_OPB[2]) , .INC (INT_OPB[3]) , .TWOPOS (INT_MULTIPLIER[4]) , .TWONEG (INT_MULTIPLIER[5]) , .ONEPOS (INT_MULTIPLIER[6]) , .ONENEG (INT_MULTIPLIER[7]) );
   PP_LOW PPL_1 (.INA (INT_OPA[0]) , .INB (INV_MULTIPLICAND[0]) , .TWONEG (INT_MULTIPLIER[5]) , .ONEPOS (INT_MULTIPLIER[6]) , .ONENEG (INT_MULTIPLIER[7]) , .PPBIT (SUMMAND[4]) );
   R_GATE RGATE_1 (.INA (INT_OPB[1]) , .INB (INT_OPB[2]) , .INC (INT_OPB[3]) , .PPBIT (SUMMAND[5]) );
   PP_MIDDLE PPM_16 (.INA (INT_OPA[0]) , .INB (INV_MULTIPLICAND[0]) , .INC (INT_OPA[1]) , .IND (INV_MULTIPLICAND[1]) , .TWOPOS (INT_MULTIPLIER[4]) , .TWONEG (INT_MULTIPLIER[5]) , .ONEPOS (INT_MULTIPLIER[6]) , .ONENEG (INT_MULTIPLIER[7]) , .PPBIT (SUMMAND[7]) );
   PP_MIDDLE PPM_17 (.INA (INT_OPA[1]) , .INB (INV_MULTIPLICAND[1]) , .INC (INT_OPA[2]) , .IND (INV_MULTIPLICAND[2]) , .TWOPOS (INT_MULTIPLIER[4]) , .TWONEG (INT_MULTIPLIER[5]) , .ONEPOS (INT_MULTIPLIER[6]) , .ONENEG (INT_MULTIPLIER[7]) , .PPBIT (SUMMAND[9]) );
   PP_MIDDLE PPM_18 (.INA (INT_OPA[2]) , .INB (INV_MULTIPLICAND[2]) , .INC (INT_OPA[3]) , .IND (INV_MULTIPLICAND[3]) , .TWOPOS (INT_MULTIPLIER[4]) , .TWONEG (INT_MULTIPLIER[5]) , .ONEPOS (INT_MULTIPLIER[6]) , .ONENEG (INT_MULTIPLIER[7]) , .PPBIT (SUMMAND[13]) );
   PP_MIDDLE PPM_19 (.INA (INT_OPA[3]) , .INB (INV_MULTIPLICAND[3]) , .INC (INT_OPA[4]) , .IND (INV_MULTIPLICAND[4]) , .TWOPOS (INT_MULTIPLIER[4]) , .TWONEG (INT_MULTIPLIER[5]) , .ONEPOS (INT_MULTIPLIER[6]) , .ONENEG (INT_MULTIPLIER[7]) , .PPBIT (SUMMAND[16]) );
   PP_MIDDLE PPM_20 (.INA (INT_OPA[4]) , .INB (INV_MULTIPLICAND[4]) , .INC (INT_OPA[5]) , .IND (INV_MULTIPLICAND[5]) , .TWOPOS (INT_MULTIPLIER[4]) , .TWONEG (INT_MULTIPLIER[5]) , .ONEPOS (INT_MULTIPLIER[6]) , .ONENEG (INT_MULTIPLIER[7]) , .PPBIT (SUMMAND[21]) );
   PP_MIDDLE PPM_21 (.INA (INT_OPA[5]) , .INB (INV_MULTIPLICAND[5]) , .INC (INT_OPA[6]) , .IND (INV_MULTIPLICAND[6]) , .TWOPOS (INT_MULTIPLIER[4]) , .TWONEG (INT_MULTIPLIER[5]) , .ONEPOS (INT_MULTIPLIER[6]) , .ONENEG (INT_MULTIPLIER[7]) , .PPBIT (SUMMAND[25]) );
   PP_MIDDLE PPM_22 (.INA (INT_OPA[6]) , .INB (INV_MULTIPLICAND[6]) , .INC (INT_OPA[7]) , .IND (INV_MULTIPLICAND[7]) , .TWOPOS (INT_MULTIPLIER[4]) , .TWONEG (INT_MULTIPLIER[5]) , .ONEPOS (INT_MULTIPLIER[6]) , .ONENEG (INT_MULTIPLIER[7]) , .PPBIT (SUMMAND[31]) );
   PP_MIDDLE PPM_23 (.INA (INT_OPA[7]) , .INB (INV_MULTIPLICAND[7]) , .INC (INT_OPA[8]) , .IND (INV_MULTIPLICAND[8]) , .TWOPOS (INT_MULTIPLIER[4]) , .TWONEG (INT_MULTIPLIER[5]) , .ONEPOS (INT_MULTIPLIER[6]) , .ONENEG (INT_MULTIPLIER[7]) , .PPBIT (SUMMAND[36]) );
   PP_MIDDLE PPM_24 (.INA (INT_OPA[8]) , .INB (INV_MULTIPLICAND[8]) , .INC (INT_OPA[9]) , .IND (INV_MULTIPLICAND[9]) , .TWOPOS (INT_MULTIPLIER[4]) , .TWONEG (INT_MULTIPLIER[5]) , .ONEPOS (INT_MULTIPLIER[6]) , .ONENEG (INT_MULTIPLIER[7]) , .PPBIT (SUMMAND[43]) );
   PP_MIDDLE PPM_25 (.INA (INT_OPA[9]) , .INB (INV_MULTIPLICAND[9]) , .INC (INT_OPA[10]) , .IND (INV_MULTIPLICAND[10]) , .TWOPOS (INT_MULTIPLIER[4]) , .TWONEG (INT_MULTIPLIER[5]) , .ONEPOS (INT_MULTIPLIER[6]) , .ONENEG (INT_MULTIPLIER[7]) , .PPBIT (SUMMAND[49]) );
   PP_MIDDLE PPM_26 (.INA (INT_OPA[10]) , .INB (INV_MULTIPLICAND[10]) , .INC (INT_OPA[11]) , .IND (INV_MULTIPLICAND[11]) , .TWOPOS (INT_MULTIPLIER[4]) , .TWONEG (INT_MULTIPLIER[5]) , .ONEPOS (INT_MULTIPLIER[6]) , .ONENEG (INT_MULTIPLIER[7]) , .PPBIT (SUMMAND[57]) );
   PP_MIDDLE PPM_27 (.INA (INT_OPA[11]) , .INB (INV_MULTIPLICAND[11]) , .INC (INT_OPA[12]) , .IND (INV_MULTIPLICAND[12]) , .TWOPOS (INT_MULTIPLIER[4]) , .TWONEG (INT_MULTIPLIER[5]) , .ONEPOS (INT_MULTIPLIER[6]) , .ONENEG (INT_MULTIPLIER[7]) , .PPBIT (SUMMAND[64]) );
   PP_MIDDLE PPM_28 (.INA (INT_OPA[12]) , .INB (INV_MULTIPLICAND[12]) , .INC (INT_OPA[13]) , .IND (INV_MULTIPLICAND[13]) , .TWOPOS (INT_MULTIPLIER[4]) , .TWONEG (INT_MULTIPLIER[5]) , .ONEPOS (INT_MULTIPLIER[6]) , .ONENEG (INT_MULTIPLIER[7]) , .PPBIT (SUMMAND[73]) );
   PP_MIDDLE PPM_29 (.INA (INT_OPA[13]) , .INB (INV_MULTIPLICAND[13]) , .INC (INT_OPA[14]) , .IND (INV_MULTIPLICAND[14]) , .TWOPOS (INT_MULTIPLIER[4]) , .TWONEG (INT_MULTIPLIER[5]) , .ONEPOS (INT_MULTIPLIER[6]) , .ONENEG (INT_MULTIPLIER[7]) , .PPBIT (SUMMAND[81]) );
   PP_MIDDLE PPM_30 (.INA (INT_OPA[14]) , .INB (INV_MULTIPLICAND[14]) , .INC (INT_OPA[15]) , .IND (INV_MULTIPLICAND[15]) , .TWOPOS (INT_MULTIPLIER[4]) , .TWONEG (INT_MULTIPLIER[5]) , .ONEPOS (INT_MULTIPLIER[6]) , .ONENEG (INT_MULTIPLIER[7]) , .PPBIT (SUMMAND[90]) );
   PP_MIDDLE PPM_31 (.INA (INT_OPA[15]) , .INB (INV_MULTIPLICAND[15]) , .INC (INT_OPA[16]) , .IND (INV_MULTIPLICAND[16]) , .TWOPOS (INT_MULTIPLIER[4]) , .TWONEG (INT_MULTIPLIER[5]) , .ONEPOS (INT_MULTIPLIER[6]) , .ONENEG (INT_MULTIPLIER[7]) , .PPBIT (SUMMAND[97]) );
   assign SUMMAND[98] = LOGIC_ONE;
   PP_HIGH PPH_1 (.INA (INT_OPA[16]) , .INB (INV_MULTIPLICAND[16]) , .TWOPOS (INT_MULTIPLIER[4]) , .TWONEG (INT_MULTIPLIER[5]) , .ONEPOS (INT_MULTIPLIER[6]) , .ONENEG (INT_MULTIPLIER[7]) , .PPBIT (SUMMAND[105]) );
   DECODER DEC_2 (.INA (INT_OPB[3]) , .INB (INT_OPB[4]) , .INC (INT_OPB[5]) , .TWOPOS (INT_MULTIPLIER[8]) , .TWONEG (INT_MULTIPLIER[9]) , .ONEPOS (INT_MULTIPLIER[10]) , .ONENEG (INT_MULTIPLIER[11]) );
   PP_LOW PPL_2 (.INA (INT_OPA[0]) , .INB (INV_MULTIPLICAND[0]) , .TWONEG (INT_MULTIPLIER[9]) , .ONEPOS (INT_MULTIPLIER[10]) , .ONENEG (INT_MULTIPLIER[11]) , .PPBIT (SUMMAND[10]) );
   R_GATE RGATE_2 (.INA (INT_OPB[3]) , .INB (INT_OPB[4]) , .INC (INT_OPB[5]) , .PPBIT (SUMMAND[11]) );
   PP_MIDDLE PPM_32 (.INA (INT_OPA[0]) , .INB (INV_MULTIPLICAND[0]) , .INC (INT_OPA[1]) , .IND (INV_MULTIPLICAND[1]) , .TWOPOS (INT_MULTIPLIER[8]) , .TWONEG (INT_MULTIPLIER[9]) , .ONEPOS (INT_MULTIPLIER[10]) , .ONENEG (INT_MULTIPLIER[11]) , .PPBIT (SUMMAND[14]) );
   PP_MIDDLE PPM_33 (.INA (INT_OPA[1]) , .INB (INV_MULTIPLICAND[1]) , .INC (INT_OPA[2]) , .IND (INV_MULTIPLICAND[2]) , .TWOPOS (INT_MULTIPLIER[8]) , .TWONEG (INT_MULTIPLIER[9]) , .ONEPOS (INT_MULTIPLIER[10]) , .ONENEG (INT_MULTIPLIER[11]) , .PPBIT (SUMMAND[17]) );
   PP_MIDDLE PPM_34 (.INA (INT_OPA[2]) , .INB (INV_MULTIPLICAND[2]) , .INC (INT_OPA[3]) , .IND (INV_MULTIPLICAND[3]) , .TWOPOS (INT_MULTIPLIER[8]) , .TWONEG (INT_MULTIPLIER[9]) , .ONEPOS (INT_MULTIPLIER[10]) , .ONENEG (INT_MULTIPLIER[11]) , .PPBIT (SUMMAND[22]) );
   PP_MIDDLE PPM_35 (.INA (INT_OPA[3]) , .INB (INV_MULTIPLICAND[3]) , .INC (INT_OPA[4]) , .IND (INV_MULTIPLICAND[4]) , .TWOPOS (INT_MULTIPLIER[8]) , .TWONEG (INT_MULTIPLIER[9]) , .ONEPOS (INT_MULTIPLIER[10]) , .ONENEG (INT_MULTIPLIER[11]) , .PPBIT (SUMMAND[26]) );
   PP_MIDDLE PPM_36 (.INA (INT_OPA[4]) , .INB (INV_MULTIPLICAND[4]) , .INC (INT_OPA[5]) , .IND (INV_MULTIPLICAND[5]) , .TWOPOS (INT_MULTIPLIER[8]) , .TWONEG (INT_MULTIPLIER[9]) , .ONEPOS (INT_MULTIPLIER[10]) , .ONENEG (INT_MULTIPLIER[11]) , .PPBIT (SUMMAND[32]) );
   PP_MIDDLE PPM_37 (.INA (INT_OPA[5]) , .INB (INV_MULTIPLICAND[5]) , .INC (INT_OPA[6]) , .IND (INV_MULTIPLICAND[6]) , .TWOPOS (INT_MULTIPLIER[8]) , .TWONEG (INT_MULTIPLIER[9]) , .ONEPOS (INT_MULTIPLIER[10]) , .ONENEG (INT_MULTIPLIER[11]) , .PPBIT (SUMMAND[37]) );
   PP_MIDDLE PPM_38 (.INA (INT_OPA[6]) , .INB (INV_MULTIPLICAND[6]) , .INC (INT_OPA[7]) , .IND (INV_MULTIPLICAND[7]) , .TWOPOS (INT_MULTIPLIER[8]) , .TWONEG (INT_MULTIPLIER[9]) , .ONEPOS (INT_MULTIPLIER[10]) , .ONENEG (INT_MULTIPLIER[11]) , .PPBIT (SUMMAND[44]) );
   PP_MIDDLE PPM_39 (.INA (INT_OPA[7]) , .INB (INV_MULTIPLICAND[7]) , .INC (INT_OPA[8]) , .IND (INV_MULTIPLICAND[8]) , .TWOPOS (INT_MULTIPLIER[8]) , .TWONEG (INT_MULTIPLIER[9]) , .ONEPOS (INT_MULTIPLIER[10]) , .ONENEG (INT_MULTIPLIER[11]) , .PPBIT (SUMMAND[50]) );
   PP_MIDDLE PPM_40 (.INA (INT_OPA[8]) , .INB (INV_MULTIPLICAND[8]) , .INC (INT_OPA[9]) , .IND (INV_MULTIPLICAND[9]) , .TWOPOS (INT_MULTIPLIER[8]) , .TWONEG (INT_MULTIPLIER[9]) , .ONEPOS (INT_MULTIPLIER[10]) , .ONENEG (INT_MULTIPLIER[11]) , .PPBIT (SUMMAND[58]) );
   PP_MIDDLE PPM_41 (.INA (INT_OPA[9]) , .INB (INV_MULTIPLICAND[9]) , .INC (INT_OPA[10]) , .IND (INV_MULTIPLICAND[10]) , .TWOPOS (INT_MULTIPLIER[8]) , .TWONEG (INT_MULTIPLIER[9]) , .ONEPOS (INT_MULTIPLIER[10]) , .ONENEG (INT_MULTIPLIER[11]) , .PPBIT (SUMMAND[65]) );
   PP_MIDDLE PPM_42 (.INA (INT_OPA[10]) , .INB (INV_MULTIPLICAND[10]) , .INC (INT_OPA[11]) , .IND (INV_MULTIPLICAND[11]) , .TWOPOS (INT_MULTIPLIER[8]) , .TWONEG (INT_MULTIPLIER[9]) , .ONEPOS (INT_MULTIPLIER[10]) , .ONENEG (INT_MULTIPLIER[11]) , .PPBIT (SUMMAND[74]) );
   PP_MIDDLE PPM_43 (.INA (INT_OPA[11]) , .INB (INV_MULTIPLICAND[11]) , .INC (INT_OPA[12]) , .IND (INV_MULTIPLICAND[12]) , .TWOPOS (INT_MULTIPLIER[8]) , .TWONEG (INT_MULTIPLIER[9]) , .ONEPOS (INT_MULTIPLIER[10]) , .ONENEG (INT_MULTIPLIER[11]) , .PPBIT (SUMMAND[82]) );
   PP_MIDDLE PPM_44 (.INA (INT_OPA[12]) , .INB (INV_MULTIPLICAND[12]) , .INC (INT_OPA[13]) , .IND (INV_MULTIPLICAND[13]) , .TWOPOS (INT_MULTIPLIER[8]) , .TWONEG (INT_MULTIPLIER[9]) , .ONEPOS (INT_MULTIPLIER[10]) , .ONENEG (INT_MULTIPLIER[11]) , .PPBIT (SUMMAND[91]) );
   PP_MIDDLE PPM_45 (.INA (INT_OPA[13]) , .INB (INV_MULTIPLICAND[13]) , .INC (INT_OPA[14]) , .IND (INV_MULTIPLICAND[14]) , .TWOPOS (INT_MULTIPLIER[8]) , .TWONEG (INT_MULTIPLIER[9]) , .ONEPOS (INT_MULTIPLIER[10]) , .ONENEG (INT_MULTIPLIER[11]) , .PPBIT (SUMMAND[99]) );
   PP_MIDDLE PPM_46 (.INA (INT_OPA[14]) , .INB (INV_MULTIPLICAND[14]) , .INC (INT_OPA[15]) , .IND (INV_MULTIPLICAND[15]) , .TWOPOS (INT_MULTIPLIER[8]) , .TWONEG (INT_MULTIPLIER[9]) , .ONEPOS (INT_MULTIPLIER[10]) , .ONENEG (INT_MULTIPLIER[11]) , .PPBIT (SUMMAND[106]) );
   PP_MIDDLE PPM_47 (.INA (INT_OPA[15]) , .INB (INV_MULTIPLICAND[15]) , .INC (INT_OPA[16]) , .IND (INV_MULTIPLICAND[16]) , .TWOPOS (INT_MULTIPLIER[8]) , .TWONEG (INT_MULTIPLIER[9]) , .ONEPOS (INT_MULTIPLIER[10]) , .ONENEG (INT_MULTIPLIER[11]) , .PPBIT (SUMMAND[112]) );
   assign SUMMAND[113] = LOGIC_ONE;
   PP_HIGH PPH_2 (.INA (INT_OPA[16]) , .INB (INV_MULTIPLICAND[16]) , .TWOPOS (INT_MULTIPLIER[8]) , .TWONEG (INT_MULTIPLIER[9]) , .ONEPOS (INT_MULTIPLIER[10]) , .ONENEG (INT_MULTIPLIER[11]) , .PPBIT (SUMMAND[119]) );
   DECODER DEC_3 (.INA (INT_OPB[5]) , .INB (INT_OPB[6]) , .INC (INT_OPB[7]) , .TWOPOS (INT_MULTIPLIER[12]) , .TWONEG (INT_MULTIPLIER[13]) , .ONEPOS (INT_MULTIPLIER[14]) , .ONENEG (INT_MULTIPLIER[15]) );
   PP_LOW PPL_3 (.INA (INT_OPA[0]) , .INB (INV_MULTIPLICAND[0]) , .TWONEG (INT_MULTIPLIER[13]) , .ONEPOS (INT_MULTIPLIER[14]) , .ONENEG (INT_MULTIPLIER[15]) , .PPBIT (SUMMAND[18]) );
   R_GATE RGATE_3 (.INA (INT_OPB[5]) , .INB (INT_OPB[6]) , .INC (INT_OPB[7]) , .PPBIT (SUMMAND[19]) );
   PP_MIDDLE PPM_48 (.INA (INT_OPA[0]) , .INB (INV_MULTIPLICAND[0]) , .INC (INT_OPA[1]) , .IND (INV_MULTIPLICAND[1]) , .TWOPOS (INT_MULTIPLIER[12]) , .TWONEG (INT_MULTIPLIER[13]) , .ONEPOS (INT_MULTIPLIER[14]) , .ONENEG (INT_MULTIPLIER[15]) , .PPBIT (SUMMAND[23]) );
   PP_MIDDLE PPM_49 (.INA (INT_OPA[1]) , .INB (INV_MULTIPLICAND[1]) , .INC (INT_OPA[2]) , .IND (INV_MULTIPLICAND[2]) , .TWOPOS (INT_MULTIPLIER[12]) , .TWONEG (INT_MULTIPLIER[13]) , .ONEPOS (INT_MULTIPLIER[14]) , .ONENEG (INT_MULTIPLIER[15]) , .PPBIT (SUMMAND[27]) );
   PP_MIDDLE PPM_50 (.INA (INT_OPA[2]) , .INB (INV_MULTIPLICAND[2]) , .INC (INT_OPA[3]) , .IND (INV_MULTIPLICAND[3]) , .TWOPOS (INT_MULTIPLIER[12]) , .TWONEG (INT_MULTIPLIER[13]) , .ONEPOS (INT_MULTIPLIER[14]) , .ONENEG (INT_MULTIPLIER[15]) , .PPBIT (SUMMAND[33]) );
   PP_MIDDLE PPM_51 (.INA (INT_OPA[3]) , .INB (INV_MULTIPLICAND[3]) , .INC (INT_OPA[4]) , .IND (INV_MULTIPLICAND[4]) , .TWOPOS (INT_MULTIPLIER[12]) , .TWONEG (INT_MULTIPLIER[13]) , .ONEPOS (INT_MULTIPLIER[14]) , .ONENEG (INT_MULTIPLIER[15]) , .PPBIT (SUMMAND[38]) );
   PP_MIDDLE PPM_52 (.INA (INT_OPA[4]) , .INB (INV_MULTIPLICAND[4]) , .INC (INT_OPA[5]) , .IND (INV_MULTIPLICAND[5]) , .TWOPOS (INT_MULTIPLIER[12]) , .TWONEG (INT_MULTIPLIER[13]) , .ONEPOS (INT_MULTIPLIER[14]) , .ONENEG (INT_MULTIPLIER[15]) , .PPBIT (SUMMAND[45]) );
   PP_MIDDLE PPM_53 (.INA (INT_OPA[5]) , .INB (INV_MULTIPLICAND[5]) , .INC (INT_OPA[6]) , .IND (INV_MULTIPLICAND[6]) , .TWOPOS (INT_MULTIPLIER[12]) , .TWONEG (INT_MULTIPLIER[13]) , .ONEPOS (INT_MULTIPLIER[14]) , .ONENEG (INT_MULTIPLIER[15]) , .PPBIT (SUMMAND[51]) );
   PP_MIDDLE PPM_54 (.INA (INT_OPA[6]) , .INB (INV_MULTIPLICAND[6]) , .INC (INT_OPA[7]) , .IND (INV_MULTIPLICAND[7]) , .TWOPOS (INT_MULTIPLIER[12]) , .TWONEG (INT_MULTIPLIER[13]) , .ONEPOS (INT_MULTIPLIER[14]) , .ONENEG (INT_MULTIPLIER[15]) , .PPBIT (SUMMAND[59]) );
   PP_MIDDLE PPM_55 (.INA (INT_OPA[7]) , .INB (INV_MULTIPLICAND[7]) , .INC (INT_OPA[8]) , .IND (INV_MULTIPLICAND[8]) , .TWOPOS (INT_MULTIPLIER[12]) , .TWONEG (INT_MULTIPLIER[13]) , .ONEPOS (INT_MULTIPLIER[14]) , .ONENEG (INT_MULTIPLIER[15]) , .PPBIT (SUMMAND[66]) );
   PP_MIDDLE PPM_56 (.INA (INT_OPA[8]) , .INB (INV_MULTIPLICAND[8]) , .INC (INT_OPA[9]) , .IND (INV_MULTIPLICAND[9]) , .TWOPOS (INT_MULTIPLIER[12]) , .TWONEG (INT_MULTIPLIER[13]) , .ONEPOS (INT_MULTIPLIER[14]) , .ONENEG (INT_MULTIPLIER[15]) , .PPBIT (SUMMAND[75]) );
   PP_MIDDLE PPM_57 (.INA (INT_OPA[9]) , .INB (INV_MULTIPLICAND[9]) , .INC (INT_OPA[10]) , .IND (INV_MULTIPLICAND[10]) , .TWOPOS (INT_MULTIPLIER[12]) , .TWONEG (INT_MULTIPLIER[13]) , .ONEPOS (INT_MULTIPLIER[14]) , .ONENEG (INT_MULTIPLIER[15]) , .PPBIT (SUMMAND[83]) );
   PP_MIDDLE PPM_58 (.INA (INT_OPA[10]) , .INB (INV_MULTIPLICAND[10]) , .INC (INT_OPA[11]) , .IND (INV_MULTIPLICAND[11]) , .TWOPOS (INT_MULTIPLIER[12]) , .TWONEG (INT_MULTIPLIER[13]) , .ONEPOS (INT_MULTIPLIER[14]) , .ONENEG (INT_MULTIPLIER[15]) , .PPBIT (SUMMAND[92]) );
   PP_MIDDLE PPM_59 (.INA (INT_OPA[11]) , .INB (INV_MULTIPLICAND[11]) , .INC (INT_OPA[12]) , .IND (INV_MULTIPLICAND[12]) , .TWOPOS (INT_MULTIPLIER[12]) , .TWONEG (INT_MULTIPLIER[13]) , .ONEPOS (INT_MULTIPLIER[14]) , .ONENEG (INT_MULTIPLIER[15]) , .PPBIT (SUMMAND[100]) );
   PP_MIDDLE PPM_60 (.INA (INT_OPA[12]) , .INB (INV_MULTIPLICAND[12]) , .INC (INT_OPA[13]) , .IND (INV_MULTIPLICAND[13]) , .TWOPOS (INT_MULTIPLIER[12]) , .TWONEG (INT_MULTIPLIER[13]) , .ONEPOS (INT_MULTIPLIER[14]) , .ONENEG (INT_MULTIPLIER[15]) , .PPBIT (SUMMAND[107]) );
   PP_MIDDLE PPM_61 (.INA (INT_OPA[13]) , .INB (INV_MULTIPLICAND[13]) , .INC (INT_OPA[14]) , .IND (INV_MULTIPLICAND[14]) , .TWOPOS (INT_MULTIPLIER[12]) , .TWONEG (INT_MULTIPLIER[13]) , .ONEPOS (INT_MULTIPLIER[14]) , .ONENEG (INT_MULTIPLIER[15]) , .PPBIT (SUMMAND[114]) );
   PP_MIDDLE PPM_62 (.INA (INT_OPA[14]) , .INB (INV_MULTIPLICAND[14]) , .INC (INT_OPA[15]) , .IND (INV_MULTIPLICAND[15]) , .TWOPOS (INT_MULTIPLIER[12]) , .TWONEG (INT_MULTIPLIER[13]) , .ONEPOS (INT_MULTIPLIER[14]) , .ONENEG (INT_MULTIPLIER[15]) , .PPBIT (SUMMAND[120]) );
   PP_MIDDLE PPM_63 (.INA (INT_OPA[15]) , .INB (INV_MULTIPLICAND[15]) , .INC (INT_OPA[16]) , .IND (INV_MULTIPLICAND[16]) , .TWOPOS (INT_MULTIPLIER[12]) , .TWONEG (INT_MULTIPLIER[13]) , .ONEPOS (INT_MULTIPLIER[14]) , .ONENEG (INT_MULTIPLIER[15]) , .PPBIT (SUMMAND[125]) );
   assign SUMMAND[126] = LOGIC_ONE;
   PP_HIGH PPH_3 (.INA (INT_OPA[16]) , .INB (INV_MULTIPLICAND[16]) , .TWOPOS (INT_MULTIPLIER[12]) , .TWONEG (INT_MULTIPLIER[13]) , .ONEPOS (INT_MULTIPLIER[14]) , .ONENEG (INT_MULTIPLIER[15]) , .PPBIT (SUMMAND[131]) );
   DECODER DEC_4 (.INA (INT_OPB[7]) , .INB (INT_OPB[8]) , .INC (INT_OPB[9]) , .TWOPOS (INT_MULTIPLIER[16]) , .TWONEG (INT_MULTIPLIER[17]) , .ONEPOS (INT_MULTIPLIER[18]) , .ONENEG (INT_MULTIPLIER[19]) );
   PP_LOW PPL_4 (.INA (INT_OPA[0]) , .INB (INV_MULTIPLICAND[0]) , .TWONEG (INT_MULTIPLIER[17]) , .ONEPOS (INT_MULTIPLIER[18]) , .ONENEG (INT_MULTIPLIER[19]) , .PPBIT (SUMMAND[28]) );
   R_GATE RGATE_4 (.INA (INT_OPB[7]) , .INB (INT_OPB[8]) , .INC (INT_OPB[9]) , .PPBIT (SUMMAND[29]) );
   PP_MIDDLE PPM_64 (.INA (INT_OPA[0]) , .INB (INV_MULTIPLICAND[0]) , .INC (INT_OPA[1]) , .IND (INV_MULTIPLICAND[1]) , .TWOPOS (INT_MULTIPLIER[16]) , .TWONEG (INT_MULTIPLIER[17]) , .ONEPOS (INT_MULTIPLIER[18]) , .ONENEG (INT_MULTIPLIER[19]) , .PPBIT (SUMMAND[34]) );
   PP_MIDDLE PPM_65 (.INA (INT_OPA[1]) , .INB (INV_MULTIPLICAND[1]) , .INC (INT_OPA[2]) , .IND (INV_MULTIPLICAND[2]) , .TWOPOS (INT_MULTIPLIER[16]) , .TWONEG (INT_MULTIPLIER[17]) , .ONEPOS (INT_MULTIPLIER[18]) , .ONENEG (INT_MULTIPLIER[19]) , .PPBIT (SUMMAND[39]) );
   PP_MIDDLE PPM_66 (.INA (INT_OPA[2]) , .INB (INV_MULTIPLICAND[2]) , .INC (INT_OPA[3]) , .IND (INV_MULTIPLICAND[3]) , .TWOPOS (INT_MULTIPLIER[16]) , .TWONEG (INT_MULTIPLIER[17]) , .ONEPOS (INT_MULTIPLIER[18]) , .ONENEG (INT_MULTIPLIER[19]) , .PPBIT (SUMMAND[46]) );
   PP_MIDDLE PPM_67 (.INA (INT_OPA[3]) , .INB (INV_MULTIPLICAND[3]) , .INC (INT_OPA[4]) , .IND (INV_MULTIPLICAND[4]) , .TWOPOS (INT_MULTIPLIER[16]) , .TWONEG (INT_MULTIPLIER[17]) , .ONEPOS (INT_MULTIPLIER[18]) , .ONENEG (INT_MULTIPLIER[19]) , .PPBIT (SUMMAND[52]) );
   PP_MIDDLE PPM_68 (.INA (INT_OPA[4]) , .INB (INV_MULTIPLICAND[4]) , .INC (INT_OPA[5]) , .IND (INV_MULTIPLICAND[5]) , .TWOPOS (INT_MULTIPLIER[16]) , .TWONEG (INT_MULTIPLIER[17]) , .ONEPOS (INT_MULTIPLIER[18]) , .ONENEG (INT_MULTIPLIER[19]) , .PPBIT (SUMMAND[60]) );
   PP_MIDDLE PPM_69 (.INA (INT_OPA[5]) , .INB (INV_MULTIPLICAND[5]) , .INC (INT_OPA[6]) , .IND (INV_MULTIPLICAND[6]) , .TWOPOS (INT_MULTIPLIER[16]) , .TWONEG (INT_MULTIPLIER[17]) , .ONEPOS (INT_MULTIPLIER[18]) , .ONENEG (INT_MULTIPLIER[19]) , .PPBIT (SUMMAND[67]) );
   PP_MIDDLE PPM_70 (.INA (INT_OPA[6]) , .INB (INV_MULTIPLICAND[6]) , .INC (INT_OPA[7]) , .IND (INV_MULTIPLICAND[7]) , .TWOPOS (INT_MULTIPLIER[16]) , .TWONEG (INT_MULTIPLIER[17]) , .ONEPOS (INT_MULTIPLIER[18]) , .ONENEG (INT_MULTIPLIER[19]) , .PPBIT (SUMMAND[76]) );
   PP_MIDDLE PPM_71 (.INA (INT_OPA[7]) , .INB (INV_MULTIPLICAND[7]) , .INC (INT_OPA[8]) , .IND (INV_MULTIPLICAND[8]) , .TWOPOS (INT_MULTIPLIER[16]) , .TWONEG (INT_MULTIPLIER[17]) , .ONEPOS (INT_MULTIPLIER[18]) , .ONENEG (INT_MULTIPLIER[19]) , .PPBIT (SUMMAND[84]) );
   PP_MIDDLE PPM_72 (.INA (INT_OPA[8]) , .INB (INV_MULTIPLICAND[8]) , .INC (INT_OPA[9]) , .IND (INV_MULTIPLICAND[9]) , .TWOPOS (INT_MULTIPLIER[16]) , .TWONEG (INT_MULTIPLIER[17]) , .ONEPOS (INT_MULTIPLIER[18]) , .ONENEG (INT_MULTIPLIER[19]) , .PPBIT (SUMMAND[93]) );
   PP_MIDDLE PPM_73 (.INA (INT_OPA[9]) , .INB (INV_MULTIPLICAND[9]) , .INC (INT_OPA[10]) , .IND (INV_MULTIPLICAND[10]) , .TWOPOS (INT_MULTIPLIER[16]) , .TWONEG (INT_MULTIPLIER[17]) , .ONEPOS (INT_MULTIPLIER[18]) , .ONENEG (INT_MULTIPLIER[19]) , .PPBIT (SUMMAND[101]) );
   PP_MIDDLE PPM_74 (.INA (INT_OPA[10]) , .INB (INV_MULTIPLICAND[10]) , .INC (INT_OPA[11]) , .IND (INV_MULTIPLICAND[11]) , .TWOPOS (INT_MULTIPLIER[16]) , .TWONEG (INT_MULTIPLIER[17]) , .ONEPOS (INT_MULTIPLIER[18]) , .ONENEG (INT_MULTIPLIER[19]) , .PPBIT (SUMMAND[108]) );
   PP_MIDDLE PPM_75 (.INA (INT_OPA[11]) , .INB (INV_MULTIPLICAND[11]) , .INC (INT_OPA[12]) , .IND (INV_MULTIPLICAND[12]) , .TWOPOS (INT_MULTIPLIER[16]) , .TWONEG (INT_MULTIPLIER[17]) , .ONEPOS (INT_MULTIPLIER[18]) , .ONENEG (INT_MULTIPLIER[19]) , .PPBIT (SUMMAND[115]) );
   PP_MIDDLE PPM_76 (.INA (INT_OPA[12]) , .INB (INV_MULTIPLICAND[12]) , .INC (INT_OPA[13]) , .IND (INV_MULTIPLICAND[13]) , .TWOPOS (INT_MULTIPLIER[16]) , .TWONEG (INT_MULTIPLIER[17]) , .ONEPOS (INT_MULTIPLIER[18]) , .ONENEG (INT_MULTIPLIER[19]) , .PPBIT (SUMMAND[121]) );
   PP_MIDDLE PPM_77 (.INA (INT_OPA[13]) , .INB (INV_MULTIPLICAND[13]) , .INC (INT_OPA[14]) , .IND (INV_MULTIPLICAND[14]) , .TWOPOS (INT_MULTIPLIER[16]) , .TWONEG (INT_MULTIPLIER[17]) , .ONEPOS (INT_MULTIPLIER[18]) , .ONENEG (INT_MULTIPLIER[19]) , .PPBIT (SUMMAND[127]) );
   PP_MIDDLE PPM_78 (.INA (INT_OPA[14]) , .INB (INV_MULTIPLICAND[14]) , .INC (INT_OPA[15]) , .IND (INV_MULTIPLICAND[15]) , .TWOPOS (INT_MULTIPLIER[16]) , .TWONEG (INT_MULTIPLIER[17]) , .ONEPOS (INT_MULTIPLIER[18]) , .ONENEG (INT_MULTIPLIER[19]) , .PPBIT (SUMMAND[132]) );
   PP_MIDDLE PPM_79 (.INA (INT_OPA[15]) , .INB (INV_MULTIPLICAND[15]) , .INC (INT_OPA[16]) , .IND (INV_MULTIPLICAND[16]) , .TWOPOS (INT_MULTIPLIER[16]) , .TWONEG (INT_MULTIPLIER[17]) , .ONEPOS (INT_MULTIPLIER[18]) , .ONENEG (INT_MULTIPLIER[19]) , .PPBIT (SUMMAND[136]) );
   assign SUMMAND[137] = LOGIC_ONE;
   PP_HIGH PPH_4 (.INA (INT_OPA[16]) , .INB (INV_MULTIPLICAND[16]) , .TWOPOS (INT_MULTIPLIER[16]) , .TWONEG (INT_MULTIPLIER[17]) , .ONEPOS (INT_MULTIPLIER[18]) , .ONENEG (INT_MULTIPLIER[19]) , .PPBIT (SUMMAND[141]) );
   DECODER DEC_5 (.INA (INT_OPB[9]) , .INB (INT_OPB[10]) , .INC (INT_OPB[11]) , .TWOPOS (INT_MULTIPLIER[20]) , .TWONEG (INT_MULTIPLIER[21]) , .ONEPOS (INT_MULTIPLIER[22]) , .ONENEG (INT_MULTIPLIER[23]) );
   PP_LOW PPL_5 (.INA (INT_OPA[0]) , .INB (INV_MULTIPLICAND[0]) , .TWONEG (INT_MULTIPLIER[21]) , .ONEPOS (INT_MULTIPLIER[22]) , .ONENEG (INT_MULTIPLIER[23]) , .PPBIT (SUMMAND[40]) );
   R_GATE RGATE_5 (.INA (INT_OPB[9]) , .INB (INT_OPB[10]) , .INC (INT_OPB[11]) , .PPBIT (SUMMAND[41]) );
   PP_MIDDLE PPM_80 (.INA (INT_OPA[0]) , .INB (INV_MULTIPLICAND[0]) , .INC (INT_OPA[1]) , .IND (INV_MULTIPLICAND[1]) , .TWOPOS (INT_MULTIPLIER[20]) , .TWONEG (INT_MULTIPLIER[21]) , .ONEPOS (INT_MULTIPLIER[22]) , .ONENEG (INT_MULTIPLIER[23]) , .PPBIT (SUMMAND[47]) );
   PP_MIDDLE PPM_81 (.INA (INT_OPA[1]) , .INB (INV_MULTIPLICAND[1]) , .INC (INT_OPA[2]) , .IND (INV_MULTIPLICAND[2]) , .TWOPOS (INT_MULTIPLIER[20]) , .TWONEG (INT_MULTIPLIER[21]) , .ONEPOS (INT_MULTIPLIER[22]) , .ONENEG (INT_MULTIPLIER[23]) , .PPBIT (SUMMAND[53]) );
   PP_MIDDLE PPM_82 (.INA (INT_OPA[2]) , .INB (INV_MULTIPLICAND[2]) , .INC (INT_OPA[3]) , .IND (INV_MULTIPLICAND[3]) , .TWOPOS (INT_MULTIPLIER[20]) , .TWONEG (INT_MULTIPLIER[21]) , .ONEPOS (INT_MULTIPLIER[22]) , .ONENEG (INT_MULTIPLIER[23]) , .PPBIT (SUMMAND[61]) );
   PP_MIDDLE PPM_83 (.INA (INT_OPA[3]) , .INB (INV_MULTIPLICAND[3]) , .INC (INT_OPA[4]) , .IND (INV_MULTIPLICAND[4]) , .TWOPOS (INT_MULTIPLIER[20]) , .TWONEG (INT_MULTIPLIER[21]) , .ONEPOS (INT_MULTIPLIER[22]) , .ONENEG (INT_MULTIPLIER[23]) , .PPBIT (SUMMAND[68]) );
   PP_MIDDLE PPM_84 (.INA (INT_OPA[4]) , .INB (INV_MULTIPLICAND[4]) , .INC (INT_OPA[5]) , .IND (INV_MULTIPLICAND[5]) , .TWOPOS (INT_MULTIPLIER[20]) , .TWONEG (INT_MULTIPLIER[21]) , .ONEPOS (INT_MULTIPLIER[22]) , .ONENEG (INT_MULTIPLIER[23]) , .PPBIT (SUMMAND[77]) );
   PP_MIDDLE PPM_85 (.INA (INT_OPA[5]) , .INB (INV_MULTIPLICAND[5]) , .INC (INT_OPA[6]) , .IND (INV_MULTIPLICAND[6]) , .TWOPOS (INT_MULTIPLIER[20]) , .TWONEG (INT_MULTIPLIER[21]) , .ONEPOS (INT_MULTIPLIER[22]) , .ONENEG (INT_MULTIPLIER[23]) , .PPBIT (SUMMAND[85]) );
   PP_MIDDLE PPM_86 (.INA (INT_OPA[6]) , .INB (INV_MULTIPLICAND[6]) , .INC (INT_OPA[7]) , .IND (INV_MULTIPLICAND[7]) , .TWOPOS (INT_MULTIPLIER[20]) , .TWONEG (INT_MULTIPLIER[21]) , .ONEPOS (INT_MULTIPLIER[22]) , .ONENEG (INT_MULTIPLIER[23]) , .PPBIT (SUMMAND[94]) );
   PP_MIDDLE PPM_87 (.INA (INT_OPA[7]) , .INB (INV_MULTIPLICAND[7]) , .INC (INT_OPA[8]) , .IND (INV_MULTIPLICAND[8]) , .TWOPOS (INT_MULTIPLIER[20]) , .TWONEG (INT_MULTIPLIER[21]) , .ONEPOS (INT_MULTIPLIER[22]) , .ONENEG (INT_MULTIPLIER[23]) , .PPBIT (SUMMAND[102]) );
   PP_MIDDLE PPM_88 (.INA (INT_OPA[8]) , .INB (INV_MULTIPLICAND[8]) , .INC (INT_OPA[9]) , .IND (INV_MULTIPLICAND[9]) , .TWOPOS (INT_MULTIPLIER[20]) , .TWONEG (INT_MULTIPLIER[21]) , .ONEPOS (INT_MULTIPLIER[22]) , .ONENEG (INT_MULTIPLIER[23]) , .PPBIT (SUMMAND[109]) );
   PP_MIDDLE PPM_89 (.INA (INT_OPA[9]) , .INB (INV_MULTIPLICAND[9]) , .INC (INT_OPA[10]) , .IND (INV_MULTIPLICAND[10]) , .TWOPOS (INT_MULTIPLIER[20]) , .TWONEG (INT_MULTIPLIER[21]) , .ONEPOS (INT_MULTIPLIER[22]) , .ONENEG (INT_MULTIPLIER[23]) , .PPBIT (SUMMAND[116]) );
   PP_MIDDLE PPM_90 (.INA (INT_OPA[10]) , .INB (INV_MULTIPLICAND[10]) , .INC (INT_OPA[11]) , .IND (INV_MULTIPLICAND[11]) , .TWOPOS (INT_MULTIPLIER[20]) , .TWONEG (INT_MULTIPLIER[21]) , .ONEPOS (INT_MULTIPLIER[22]) , .ONENEG (INT_MULTIPLIER[23]) , .PPBIT (SUMMAND[122]) );
   PP_MIDDLE PPM_91 (.INA (INT_OPA[11]) , .INB (INV_MULTIPLICAND[11]) , .INC (INT_OPA[12]) , .IND (INV_MULTIPLICAND[12]) , .TWOPOS (INT_MULTIPLIER[20]) , .TWONEG (INT_MULTIPLIER[21]) , .ONEPOS (INT_MULTIPLIER[22]) , .ONENEG (INT_MULTIPLIER[23]) , .PPBIT (SUMMAND[128]) );
   PP_MIDDLE PPM_92 (.INA (INT_OPA[12]) , .INB (INV_MULTIPLICAND[12]) , .INC (INT_OPA[13]) , .IND (INV_MULTIPLICAND[13]) , .TWOPOS (INT_MULTIPLIER[20]) , .TWONEG (INT_MULTIPLIER[21]) , .ONEPOS (INT_MULTIPLIER[22]) , .ONENEG (INT_MULTIPLIER[23]) , .PPBIT (SUMMAND[133]) );
   PP_MIDDLE PPM_93 (.INA (INT_OPA[13]) , .INB (INV_MULTIPLICAND[13]) , .INC (INT_OPA[14]) , .IND (INV_MULTIPLICAND[14]) , .TWOPOS (INT_MULTIPLIER[20]) , .TWONEG (INT_MULTIPLIER[21]) , .ONEPOS (INT_MULTIPLIER[22]) , .ONENEG (INT_MULTIPLIER[23]) , .PPBIT (SUMMAND[138]) );
   PP_MIDDLE PPM_94 (.INA (INT_OPA[14]) , .INB (INV_MULTIPLICAND[14]) , .INC (INT_OPA[15]) , .IND (INV_MULTIPLICAND[15]) , .TWOPOS (INT_MULTIPLIER[20]) , .TWONEG (INT_MULTIPLIER[21]) , .ONEPOS (INT_MULTIPLIER[22]) , .ONENEG (INT_MULTIPLIER[23]) , .PPBIT (SUMMAND[142]) );
   PP_MIDDLE PPM_95 (.INA (INT_OPA[15]) , .INB (INV_MULTIPLICAND[15]) , .INC (INT_OPA[16]) , .IND (INV_MULTIPLICAND[16]) , .TWOPOS (INT_MULTIPLIER[20]) , .TWONEG (INT_MULTIPLIER[21]) , .ONEPOS (INT_MULTIPLIER[22]) , .ONENEG (INT_MULTIPLIER[23]) , .PPBIT (SUMMAND[145]) );
   assign SUMMAND[146] = LOGIC_ONE;
   PP_HIGH PPH_5 (.INA (INT_OPA[16]) , .INB (INV_MULTIPLICAND[16]) , .TWOPOS (INT_MULTIPLIER[20]) , .TWONEG (INT_MULTIPLIER[21]) , .ONEPOS (INT_MULTIPLIER[22]) , .ONENEG (INT_MULTIPLIER[23]) , .PPBIT (SUMMAND[149]) );
   DECODER DEC_6 (.INA (INT_OPB[11]) , .INB (INT_OPB[12]) , .INC (INT_OPB[13]) , .TWOPOS (INT_MULTIPLIER[24]) , .TWONEG (INT_MULTIPLIER[25]) , .ONEPOS (INT_MULTIPLIER[26]) , .ONENEG (INT_MULTIPLIER[27]) );
   PP_LOW PPL_6 (.INA (INT_OPA[0]) , .INB (INV_MULTIPLICAND[0]) , .TWONEG (INT_MULTIPLIER[25]) , .ONEPOS (INT_MULTIPLIER[26]) , .ONENEG (INT_MULTIPLIER[27]) , .PPBIT (SUMMAND[54]) );
   R_GATE RGATE_6 (.INA (INT_OPB[11]) , .INB (INT_OPB[12]) , .INC (INT_OPB[13]) , .PPBIT (SUMMAND[55]) );
   PP_MIDDLE PPM_96 (.INA (INT_OPA[0]) , .INB (INV_MULTIPLICAND[0]) , .INC (INT_OPA[1]) , .IND (INV_MULTIPLICAND[1]) , .TWOPOS (INT_MULTIPLIER[24]) , .TWONEG (INT_MULTIPLIER[25]) , .ONEPOS (INT_MULTIPLIER[26]) , .ONENEG (INT_MULTIPLIER[27]) , .PPBIT (SUMMAND[62]) );
   PP_MIDDLE PPM_97 (.INA (INT_OPA[1]) , .INB (INV_MULTIPLICAND[1]) , .INC (INT_OPA[2]) , .IND (INV_MULTIPLICAND[2]) , .TWOPOS (INT_MULTIPLIER[24]) , .TWONEG (INT_MULTIPLIER[25]) , .ONEPOS (INT_MULTIPLIER[26]) , .ONENEG (INT_MULTIPLIER[27]) , .PPBIT (SUMMAND[69]) );
   PP_MIDDLE PPM_98 (.INA (INT_OPA[2]) , .INB (INV_MULTIPLICAND[2]) , .INC (INT_OPA[3]) , .IND (INV_MULTIPLICAND[3]) , .TWOPOS (INT_MULTIPLIER[24]) , .TWONEG (INT_MULTIPLIER[25]) , .ONEPOS (INT_MULTIPLIER[26]) , .ONENEG (INT_MULTIPLIER[27]) , .PPBIT (SUMMAND[78]) );
   PP_MIDDLE PPM_99 (.INA (INT_OPA[3]) , .INB (INV_MULTIPLICAND[3]) , .INC (INT_OPA[4]) , .IND (INV_MULTIPLICAND[4]) , .TWOPOS (INT_MULTIPLIER[24]) , .TWONEG (INT_MULTIPLIER[25]) , .ONEPOS (INT_MULTIPLIER[26]) , .ONENEG (INT_MULTIPLIER[27]) , .PPBIT (SUMMAND[86]) );
   PP_MIDDLE PPM_100 (.INA (INT_OPA[4]) , .INB (INV_MULTIPLICAND[4]) , .INC (INT_OPA[5]) , .IND (INV_MULTIPLICAND[5]) , .TWOPOS (INT_MULTIPLIER[24]) , .TWONEG (INT_MULTIPLIER[25]) , .ONEPOS (INT_MULTIPLIER[26]) , .ONENEG (INT_MULTIPLIER[27]) , .PPBIT (SUMMAND[95]) );
   PP_MIDDLE PPM_101 (.INA (INT_OPA[5]) , .INB (INV_MULTIPLICAND[5]) , .INC (INT_OPA[6]) , .IND (INV_MULTIPLICAND[6]) , .TWOPOS (INT_MULTIPLIER[24]) , .TWONEG (INT_MULTIPLIER[25]) , .ONEPOS (INT_MULTIPLIER[26]) , .ONENEG (INT_MULTIPLIER[27]) , .PPBIT (SUMMAND[103]) );
   PP_MIDDLE PPM_102 (.INA (INT_OPA[6]) , .INB (INV_MULTIPLICAND[6]) , .INC (INT_OPA[7]) , .IND (INV_MULTIPLICAND[7]) , .TWOPOS (INT_MULTIPLIER[24]) , .TWONEG (INT_MULTIPLIER[25]) , .ONEPOS (INT_MULTIPLIER[26]) , .ONENEG (INT_MULTIPLIER[27]) , .PPBIT (SUMMAND[110]) );
   PP_MIDDLE PPM_103 (.INA (INT_OPA[7]) , .INB (INV_MULTIPLICAND[7]) , .INC (INT_OPA[8]) , .IND (INV_MULTIPLICAND[8]) , .TWOPOS (INT_MULTIPLIER[24]) , .TWONEG (INT_MULTIPLIER[25]) , .ONEPOS (INT_MULTIPLIER[26]) , .ONENEG (INT_MULTIPLIER[27]) , .PPBIT (SUMMAND[117]) );
   PP_MIDDLE PPM_104 (.INA (INT_OPA[8]) , .INB (INV_MULTIPLICAND[8]) , .INC (INT_OPA[9]) , .IND (INV_MULTIPLICAND[9]) , .TWOPOS (INT_MULTIPLIER[24]) , .TWONEG (INT_MULTIPLIER[25]) , .ONEPOS (INT_MULTIPLIER[26]) , .ONENEG (INT_MULTIPLIER[27]) , .PPBIT (SUMMAND[123]) );
   PP_MIDDLE PPM_105 (.INA (INT_OPA[9]) , .INB (INV_MULTIPLICAND[9]) , .INC (INT_OPA[10]) , .IND (INV_MULTIPLICAND[10]) , .TWOPOS (INT_MULTIPLIER[24]) , .TWONEG (INT_MULTIPLIER[25]) , .ONEPOS (INT_MULTIPLIER[26]) , .ONENEG (INT_MULTIPLIER[27]) , .PPBIT (SUMMAND[129]) );
   PP_MIDDLE PPM_106 (.INA (INT_OPA[10]) , .INB (INV_MULTIPLICAND[10]) , .INC (INT_OPA[11]) , .IND (INV_MULTIPLICAND[11]) , .TWOPOS (INT_MULTIPLIER[24]) , .TWONEG (INT_MULTIPLIER[25]) , .ONEPOS (INT_MULTIPLIER[26]) , .ONENEG (INT_MULTIPLIER[27]) , .PPBIT (SUMMAND[134]) );
   PP_MIDDLE PPM_107 (.INA (INT_OPA[11]) , .INB (INV_MULTIPLICAND[11]) , .INC (INT_OPA[12]) , .IND (INV_MULTIPLICAND[12]) , .TWOPOS (INT_MULTIPLIER[24]) , .TWONEG (INT_MULTIPLIER[25]) , .ONEPOS (INT_MULTIPLIER[26]) , .ONENEG (INT_MULTIPLIER[27]) , .PPBIT (SUMMAND[139]) );
   PP_MIDDLE PPM_108 (.INA (INT_OPA[12]) , .INB (INV_MULTIPLICAND[12]) , .INC (INT_OPA[13]) , .IND (INV_MULTIPLICAND[13]) , .TWOPOS (INT_MULTIPLIER[24]) , .TWONEG (INT_MULTIPLIER[25]) , .ONEPOS (INT_MULTIPLIER[26]) , .ONENEG (INT_MULTIPLIER[27]) , .PPBIT (SUMMAND[143]) );
   PP_MIDDLE PPM_109 (.INA (INT_OPA[13]) , .INB (INV_MULTIPLICAND[13]) , .INC (INT_OPA[14]) , .IND (INV_MULTIPLICAND[14]) , .TWOPOS (INT_MULTIPLIER[24]) , .TWONEG (INT_MULTIPLIER[25]) , .ONEPOS (INT_MULTIPLIER[26]) , .ONENEG (INT_MULTIPLIER[27]) , .PPBIT (SUMMAND[147]) );
   PP_MIDDLE PPM_110 (.INA (INT_OPA[14]) , .INB (INV_MULTIPLICAND[14]) , .INC (INT_OPA[15]) , .IND (INV_MULTIPLICAND[15]) , .TWOPOS (INT_MULTIPLIER[24]) , .TWONEG (INT_MULTIPLIER[25]) , .ONEPOS (INT_MULTIPLIER[26]) , .ONENEG (INT_MULTIPLIER[27]) , .PPBIT (SUMMAND[150]) );
   PP_MIDDLE PPM_111 (.INA (INT_OPA[15]) , .INB (INV_MULTIPLICAND[15]) , .INC (INT_OPA[16]) , .IND (INV_MULTIPLICAND[16]) , .TWOPOS (INT_MULTIPLIER[24]) , .TWONEG (INT_MULTIPLIER[25]) , .ONEPOS (INT_MULTIPLIER[26]) , .ONENEG (INT_MULTIPLIER[27]) , .PPBIT (SUMMAND[152]) );
   assign SUMMAND[153] = LOGIC_ONE;
   PP_HIGH PPH_6 (.INA (INT_OPA[16]) , .INB (INV_MULTIPLICAND[16]) , .TWOPOS (INT_MULTIPLIER[24]) , .TWONEG (INT_MULTIPLIER[25]) , .ONEPOS (INT_MULTIPLIER[26]) , .ONENEG (INT_MULTIPLIER[27]) , .PPBIT (SUMMAND[155]) );
   DECODER DEC_7 (.INA (INT_OPB[13]) , .INB (INT_OPB[14]) , .INC (INT_OPB[15]) , .TWOPOS (INT_MULTIPLIER[28]) , .TWONEG (INT_MULTIPLIER[29]) , .ONEPOS (INT_MULTIPLIER[30]) , .ONENEG (INT_MULTIPLIER[31]) );
   PP_LOW PPL_7 (.INA (INT_OPA[0]) , .INB (INV_MULTIPLICAND[0]) , .TWONEG (INT_MULTIPLIER[29]) , .ONEPOS (INT_MULTIPLIER[30]) , .ONENEG (INT_MULTIPLIER[31]) , .PPBIT (SUMMAND[70]) );
   R_GATE RGATE_7 (.INA (INT_OPB[13]) , .INB (INT_OPB[14]) , .INC (INT_OPB[15]) , .PPBIT (SUMMAND[71]) );
   PP_MIDDLE PPM_112 (.INA (INT_OPA[0]) , .INB (INV_MULTIPLICAND[0]) , .INC (INT_OPA[1]) , .IND (INV_MULTIPLICAND[1]) , .TWOPOS (INT_MULTIPLIER[28]) , .TWONEG (INT_MULTIPLIER[29]) , .ONEPOS (INT_MULTIPLIER[30]) , .ONENEG (INT_MULTIPLIER[31]) , .PPBIT (SUMMAND[79]) );
   PP_MIDDLE PPM_113 (.INA (INT_OPA[1]) , .INB (INV_MULTIPLICAND[1]) , .INC (INT_OPA[2]) , .IND (INV_MULTIPLICAND[2]) , .TWOPOS (INT_MULTIPLIER[28]) , .TWONEG (INT_MULTIPLIER[29]) , .ONEPOS (INT_MULTIPLIER[30]) , .ONENEG (INT_MULTIPLIER[31]) , .PPBIT (SUMMAND[87]) );
   PP_MIDDLE PPM_114 (.INA (INT_OPA[2]) , .INB (INV_MULTIPLICAND[2]) , .INC (INT_OPA[3]) , .IND (INV_MULTIPLICAND[3]) , .TWOPOS (INT_MULTIPLIER[28]) , .TWONEG (INT_MULTIPLIER[29]) , .ONEPOS (INT_MULTIPLIER[30]) , .ONENEG (INT_MULTIPLIER[31]) , .PPBIT (SUMMAND[96]) );
   PP_MIDDLE PPM_115 (.INA (INT_OPA[3]) , .INB (INV_MULTIPLICAND[3]) , .INC (INT_OPA[4]) , .IND (INV_MULTIPLICAND[4]) , .TWOPOS (INT_MULTIPLIER[28]) , .TWONEG (INT_MULTIPLIER[29]) , .ONEPOS (INT_MULTIPLIER[30]) , .ONENEG (INT_MULTIPLIER[31]) , .PPBIT (SUMMAND[104]) );
   PP_MIDDLE PPM_116 (.INA (INT_OPA[4]) , .INB (INV_MULTIPLICAND[4]) , .INC (INT_OPA[5]) , .IND (INV_MULTIPLICAND[5]) , .TWOPOS (INT_MULTIPLIER[28]) , .TWONEG (INT_MULTIPLIER[29]) , .ONEPOS (INT_MULTIPLIER[30]) , .ONENEG (INT_MULTIPLIER[31]) , .PPBIT (SUMMAND[111]) );
   PP_MIDDLE PPM_117 (.INA (INT_OPA[5]) , .INB (INV_MULTIPLICAND[5]) , .INC (INT_OPA[6]) , .IND (INV_MULTIPLICAND[6]) , .TWOPOS (INT_MULTIPLIER[28]) , .TWONEG (INT_MULTIPLIER[29]) , .ONEPOS (INT_MULTIPLIER[30]) , .ONENEG (INT_MULTIPLIER[31]) , .PPBIT (SUMMAND[118]) );
   PP_MIDDLE PPM_118 (.INA (INT_OPA[6]) , .INB (INV_MULTIPLICAND[6]) , .INC (INT_OPA[7]) , .IND (INV_MULTIPLICAND[7]) , .TWOPOS (INT_MULTIPLIER[28]) , .TWONEG (INT_MULTIPLIER[29]) , .ONEPOS (INT_MULTIPLIER[30]) , .ONENEG (INT_MULTIPLIER[31]) , .PPBIT (SUMMAND[124]) );
   PP_MIDDLE PPM_119 (.INA (INT_OPA[7]) , .INB (INV_MULTIPLICAND[7]) , .INC (INT_OPA[8]) , .IND (INV_MULTIPLICAND[8]) , .TWOPOS (INT_MULTIPLIER[28]) , .TWONEG (INT_MULTIPLIER[29]) , .ONEPOS (INT_MULTIPLIER[30]) , .ONENEG (INT_MULTIPLIER[31]) , .PPBIT (SUMMAND[130]) );
   PP_MIDDLE PPM_120 (.INA (INT_OPA[8]) , .INB (INV_MULTIPLICAND[8]) , .INC (INT_OPA[9]) , .IND (INV_MULTIPLICAND[9]) , .TWOPOS (INT_MULTIPLIER[28]) , .TWONEG (INT_MULTIPLIER[29]) , .ONEPOS (INT_MULTIPLIER[30]) , .ONENEG (INT_MULTIPLIER[31]) , .PPBIT (SUMMAND[135]) );
   PP_MIDDLE PPM_121 (.INA (INT_OPA[9]) , .INB (INV_MULTIPLICAND[9]) , .INC (INT_OPA[10]) , .IND (INV_MULTIPLICAND[10]) , .TWOPOS (INT_MULTIPLIER[28]) , .TWONEG (INT_MULTIPLIER[29]) , .ONEPOS (INT_MULTIPLIER[30]) , .ONENEG (INT_MULTIPLIER[31]) , .PPBIT (SUMMAND[140]) );
   PP_MIDDLE PPM_122 (.INA (INT_OPA[10]) , .INB (INV_MULTIPLICAND[10]) , .INC (INT_OPA[11]) , .IND (INV_MULTIPLICAND[11]) , .TWOPOS (INT_MULTIPLIER[28]) , .TWONEG (INT_MULTIPLIER[29]) , .ONEPOS (INT_MULTIPLIER[30]) , .ONENEG (INT_MULTIPLIER[31]) , .PPBIT (SUMMAND[144]) );
   PP_MIDDLE PPM_123 (.INA (INT_OPA[11]) , .INB (INV_MULTIPLICAND[11]) , .INC (INT_OPA[12]) , .IND (INV_MULTIPLICAND[12]) , .TWOPOS (INT_MULTIPLIER[28]) , .TWONEG (INT_MULTIPLIER[29]) , .ONEPOS (INT_MULTIPLIER[30]) , .ONENEG (INT_MULTIPLIER[31]) , .PPBIT (SUMMAND[148]) );
   PP_MIDDLE PPM_124 (.INA (INT_OPA[12]) , .INB (INV_MULTIPLICAND[12]) , .INC (INT_OPA[13]) , .IND (INV_MULTIPLICAND[13]) , .TWOPOS (INT_MULTIPLIER[28]) , .TWONEG (INT_MULTIPLIER[29]) , .ONEPOS (INT_MULTIPLIER[30]) , .ONENEG (INT_MULTIPLIER[31]) , .PPBIT (SUMMAND[151]) );
   PP_MIDDLE PPM_125 (.INA (INT_OPA[13]) , .INB (INV_MULTIPLICAND[13]) , .INC (INT_OPA[14]) , .IND (INV_MULTIPLICAND[14]) , .TWOPOS (INT_MULTIPLIER[28]) , .TWONEG (INT_MULTIPLIER[29]) , .ONEPOS (INT_MULTIPLIER[30]) , .ONENEG (INT_MULTIPLIER[31]) , .PPBIT (SUMMAND[154]) );
   PP_MIDDLE PPM_126 (.INA (INT_OPA[14]) , .INB (INV_MULTIPLICAND[14]) , .INC (INT_OPA[15]) , .IND (INV_MULTIPLICAND[15]) , .TWOPOS (INT_MULTIPLIER[28]) , .TWONEG (INT_MULTIPLIER[29]) , .ONEPOS (INT_MULTIPLIER[30]) , .ONENEG (INT_MULTIPLIER[31]) , .PPBIT (SUMMAND[156]) );
   PP_MIDDLE PPM_127 (.INA (INT_OPA[15]) , .INB (INV_MULTIPLICAND[15]) , .INC (INT_OPA[16]) , .IND (INV_MULTIPLICAND[16]) , .TWOPOS (INT_MULTIPLIER[28]) , .TWONEG (INT_MULTIPLIER[29]) , .ONEPOS (INT_MULTIPLIER[30]) , .ONENEG (INT_MULTIPLIER[31]) , .PPBIT (SUMMAND[157]) );
   assign SUMMAND[158] = LOGIC_ONE;
   PP_HIGH PPH_7 (.INA (INT_OPA[16]) , .INB (INV_MULTIPLICAND[16]) , .TWOPOS (INT_MULTIPLIER[28]) , .TWONEG (INT_MULTIPLIER[29]) , .ONEPOS (INT_MULTIPLIER[30]) , .ONENEG (INT_MULTIPLIER[31]) , .PPBIT (SUMMAND[159]) );
endmodule


module FULL_ADDER ( DATA_A, DATA_B, DATA_C, SAVE, CARRY );
input  DATA_A;
input  DATA_B;
input  DATA_C;
output SAVE;
output CARRY;
   wire TMP;
   assign TMP = DATA_A ^ DATA_B;
   assign SAVE = TMP ^ DATA_C;
   assign CARRY =  ~ (( ~ (TMP & DATA_C)) & ( ~ (DATA_A & DATA_B)));
endmodule


module HALF_ADDER ( DATA_A, DATA_B, SAVE, CARRY );
input  DATA_A;
input  DATA_B;
output SAVE;
output CARRY;
   assign SAVE = DATA_A ^ DATA_B;
   assign CARRY = DATA_A & DATA_B;
endmodule


module FLIPFLOP ( DIN, CLK, DOUT );
input  DIN;
input  CLK;
output DOUT;
   reg DOUT_reg;
   always @ ( posedge CLK ) begin
      DOUT_reg = DIN;
   end
   assign DOUT = DOUT_reg;
endmodule


module WALLACE_17_16 ( SUMMAND, CLK, CARRY, SUM );
input  [0:159] SUMMAND;
input  CLK;
output [0:30] CARRY;
output [0:31] SUM;
   wire [0:7] LATCHED_PP;
   wire [0:160] INT_CARRY;
   wire [0:203] INT_SUM;
   HALF_ADDER HA_0 (.DATA_A (SUMMAND[0]) , .DATA_B (SUMMAND[1]) , .SAVE (INT_SUM[0]) , .CARRY (INT_CARRY[0]) );
   FLIPFLOP LA_0 (.DIN (INT_SUM[0]) , .CLK (CLK) , .DOUT (INT_SUM[1]) );
   FLIPFLOP LA_1 (.DIN (INT_SUM[1]) , .CLK (CLK) , .DOUT (SUM[0]) );
   FLIPFLOP LA_2 (.DIN (INT_CARRY[0]) , .CLK (CLK) , .DOUT (INT_CARRY[1]) );
   FLIPFLOP LA_3 (.DIN (INT_CARRY[1]) , .CLK (CLK) , .DOUT (CARRY[0]) );
   assign INT_SUM[2] = SUMMAND[2];
   assign CARRY[1] = 0;
   FLIPFLOP LA_4 (.DIN (INT_SUM[2]) , .CLK (CLK) , .DOUT (INT_SUM[3]) );
   FLIPFLOP LA_5 (.DIN (INT_SUM[3]) , .CLK (CLK) , .DOUT (SUM[1]) );
   FULL_ADDER FA_0 (.DATA_A (SUMMAND[3]) , .DATA_B (SUMMAND[4]) , .DATA_C (SUMMAND[5]) , .SAVE (INT_SUM[4]) , .CARRY (INT_CARRY[2]) );
   FLIPFLOP LA_6 (.DIN (INT_SUM[4]) , .CLK (CLK) , .DOUT (INT_SUM[5]) );
   FLIPFLOP LA_7 (.DIN (INT_SUM[5]) , .CLK (CLK) , .DOUT (SUM[2]) );
   FLIPFLOP LA_8 (.DIN (INT_CARRY[2]) , .CLK (CLK) , .DOUT (INT_CARRY[3]) );
   FLIPFLOP LA_9 (.DIN (INT_CARRY[3]) , .CLK (CLK) , .DOUT (CARRY[2]) );
   HALF_ADDER HA_1 (.DATA_A (SUMMAND[6]) , .DATA_B (SUMMAND[7]) , .SAVE (INT_SUM[6]) , .CARRY (INT_CARRY[4]) );
   FLIPFLOP LA_10 (.DIN (INT_SUM[6]) , .CLK (CLK) , .DOUT (INT_SUM[7]) );
   FLIPFLOP LA_11 (.DIN (INT_SUM[7]) , .CLK (CLK) , .DOUT (SUM[3]) );
   FLIPFLOP LA_12 (.DIN (INT_CARRY[4]) , .CLK (CLK) , .DOUT (INT_CARRY[5]) );
   FLIPFLOP LA_13 (.DIN (INT_CARRY[5]) , .CLK (CLK) , .DOUT (CARRY[3]) );
   FULL_ADDER FA_1 (.DATA_A (SUMMAND[8]) , .DATA_B (SUMMAND[9]) , .DATA_C (SUMMAND[10]) , .SAVE (INT_SUM[8]) , .CARRY (INT_CARRY[8]) );
   assign INT_SUM[9] = SUMMAND[11];
   HALF_ADDER HA_2 (.DATA_A (INT_SUM[8]) , .DATA_B (INT_SUM[9]) , .SAVE (INT_SUM[10]) , .CARRY (INT_CARRY[6]) );
   FLIPFLOP LA_14 (.DIN (INT_SUM[10]) , .CLK (CLK) , .DOUT (INT_SUM[11]) );
   FLIPFLOP LA_15 (.DIN (INT_SUM[11]) , .CLK (CLK) , .DOUT (SUM[4]) );
   FLIPFLOP LA_16 (.DIN (INT_CARRY[6]) , .CLK (CLK) , .DOUT (INT_CARRY[7]) );
   FLIPFLOP LA_17 (.DIN (INT_CARRY[7]) , .CLK (CLK) , .DOUT (CARRY[4]) );
   FULL_ADDER FA_2 (.DATA_A (SUMMAND[12]) , .DATA_B (SUMMAND[13]) , .DATA_C (SUMMAND[14]) , .SAVE (INT_SUM[12]) , .CARRY (INT_CARRY[11]) );
   HALF_ADDER HA_3 (.DATA_A (INT_SUM[12]) , .DATA_B (INT_CARRY[8]) , .SAVE (INT_SUM[13]) , .CARRY (INT_CARRY[9]) );
   FLIPFLOP LA_18 (.DIN (INT_SUM[13]) , .CLK (CLK) , .DOUT (INT_SUM[14]) );
   FLIPFLOP LA_19 (.DIN (INT_SUM[14]) , .CLK (CLK) , .DOUT (SUM[5]) );
   FLIPFLOP LA_20 (.DIN (INT_CARRY[9]) , .CLK (CLK) , .DOUT (INT_CARRY[10]) );
   FLIPFLOP LA_21 (.DIN (INT_CARRY[10]) , .CLK (CLK) , .DOUT (CARRY[5]) );
   FULL_ADDER FA_3 (.DATA_A (SUMMAND[15]) , .DATA_B (SUMMAND[16]) , .DATA_C (SUMMAND[17]) , .SAVE (INT_SUM[15]) , .CARRY (INT_CARRY[14]) );
   HALF_ADDER HA_4 (.DATA_A (SUMMAND[18]) , .DATA_B (SUMMAND[19]) , .SAVE (INT_SUM[16]) , .CARRY (INT_CARRY[15]) );
   FULL_ADDER FA_4 (.DATA_A (INT_SUM[15]) , .DATA_B (INT_SUM[16]) , .DATA_C (INT_CARRY[11]) , .SAVE (INT_SUM[17]) , .CARRY (INT_CARRY[12]) );
   FLIPFLOP LA_22 (.DIN (INT_SUM[17]) , .CLK (CLK) , .DOUT (INT_SUM[18]) );
   FLIPFLOP LA_23 (.DIN (INT_SUM[18]) , .CLK (CLK) , .DOUT (SUM[6]) );
   FLIPFLOP LA_24 (.DIN (INT_CARRY[12]) , .CLK (CLK) , .DOUT (INT_CARRY[13]) );
   FLIPFLOP LA_25 (.DIN (INT_CARRY[13]) , .CLK (CLK) , .DOUT (CARRY[6]) );
   FULL_ADDER FA_5 (.DATA_A (SUMMAND[20]) , .DATA_B (SUMMAND[21]) , .DATA_C (SUMMAND[22]) , .SAVE (INT_SUM[19]) , .CARRY (INT_CARRY[17]) );
   assign INT_SUM[20] = SUMMAND[23];
   FULL_ADDER FA_6 (.DATA_A (INT_SUM[19]) , .DATA_B (INT_SUM[20]) , .DATA_C (INT_CARRY[14]) , .SAVE (INT_SUM[21]) , .CARRY (INT_CARRY[18]) );
   assign INT_SUM[23] = INT_CARRY[15];
   FLIPFLOP LA_26 (.DIN (INT_SUM[21]) , .CLK (CLK) , .DOUT (INT_SUM[22]) );
   FLIPFLOP LA_27 (.DIN (INT_SUM[23]) , .CLK (CLK) , .DOUT (INT_SUM[24]) );
   HALF_ADDER HA_5 (.DATA_A (INT_SUM[22]) , .DATA_B (INT_SUM[24]) , .SAVE (INT_SUM[25]) , .CARRY (INT_CARRY[16]) );
   FLIPFLOP LA_28 (.DIN (INT_SUM[25]) , .CLK (CLK) , .DOUT (SUM[7]) );
   FLIPFLOP LA_29 (.DIN (INT_CARRY[16]) , .CLK (CLK) , .DOUT (CARRY[7]) );
   FULL_ADDER FA_7 (.DATA_A (SUMMAND[24]) , .DATA_B (SUMMAND[25]) , .DATA_C (SUMMAND[26]) , .SAVE (INT_SUM[26]) , .CARRY (INT_CARRY[21]) );
   FULL_ADDER FA_8 (.DATA_A (SUMMAND[27]) , .DATA_B (SUMMAND[28]) , .DATA_C (SUMMAND[29]) , .SAVE (INT_SUM[27]) , .CARRY (INT_CARRY[22]) );
   FULL_ADDER FA_9 (.DATA_A (INT_SUM[26]) , .DATA_B (INT_SUM[27]) , .DATA_C (INT_CARRY[17]) , .SAVE (INT_SUM[28]) , .CARRY (INT_CARRY[23]) );
   FLIPFLOP LA_30 (.DIN (INT_SUM[28]) , .CLK (CLK) , .DOUT (INT_SUM[29]) );
   FLIPFLOP LA_31 (.DIN (INT_CARRY[18]) , .CLK (CLK) , .DOUT (INT_CARRY[19]) );
   HALF_ADDER HA_6 (.DATA_A (INT_SUM[29]) , .DATA_B (INT_CARRY[19]) , .SAVE (INT_SUM[30]) , .CARRY (INT_CARRY[20]) );
   FLIPFLOP LA_32 (.DIN (INT_SUM[30]) , .CLK (CLK) , .DOUT (SUM[8]) );
   FLIPFLOP LA_33 (.DIN (INT_CARRY[20]) , .CLK (CLK) , .DOUT (CARRY[8]) );
   FULL_ADDER FA_10 (.DATA_A (SUMMAND[30]) , .DATA_B (SUMMAND[31]) , .DATA_C (SUMMAND[32]) , .SAVE (INT_SUM[31]) , .CARRY (INT_CARRY[26]) );
   HALF_ADDER HA_7 (.DATA_A (SUMMAND[33]) , .DATA_B (SUMMAND[34]) , .SAVE (INT_SUM[32]) , .CARRY (INT_CARRY[27]) );
   FULL_ADDER FA_11 (.DATA_A (INT_SUM[31]) , .DATA_B (INT_SUM[32]) , .DATA_C (INT_CARRY[21]) , .SAVE (INT_SUM[33]) , .CARRY (INT_CARRY[28]) );
   assign INT_SUM[35] = INT_CARRY[22];
   FLIPFLOP LA_34 (.DIN (INT_SUM[33]) , .CLK (CLK) , .DOUT (INT_SUM[34]) );
   FLIPFLOP LA_35 (.DIN (INT_SUM[35]) , .CLK (CLK) , .DOUT (INT_SUM[36]) );
   FLIPFLOP LA_36 (.DIN (INT_CARRY[23]) , .CLK (CLK) , .DOUT (INT_CARRY[24]) );
   FULL_ADDER FA_12 (.DATA_A (INT_SUM[34]) , .DATA_B (INT_SUM[36]) , .DATA_C (INT_CARRY[24]) , .SAVE (INT_SUM[37]) , .CARRY (INT_CARRY[25]) );
   FLIPFLOP LA_37 (.DIN (INT_SUM[37]) , .CLK (CLK) , .DOUT (SUM[9]) );
   FLIPFLOP LA_38 (.DIN (INT_CARRY[25]) , .CLK (CLK) , .DOUT (CARRY[9]) );
   FULL_ADDER FA_13 (.DATA_A (SUMMAND[35]) , .DATA_B (SUMMAND[36]) , .DATA_C (SUMMAND[37]) , .SAVE (INT_SUM[38]) , .CARRY (INT_CARRY[31]) );
   FULL_ADDER FA_14 (.DATA_A (SUMMAND[38]) , .DATA_B (SUMMAND[39]) , .DATA_C (SUMMAND[40]) , .SAVE (INT_SUM[39]) , .CARRY (INT_CARRY[32]) );
   assign INT_SUM[40] = SUMMAND[41];
   FULL_ADDER FA_15 (.DATA_A (INT_SUM[38]) , .DATA_B (INT_SUM[39]) , .DATA_C (INT_SUM[40]) , .SAVE (INT_SUM[41]) , .CARRY (INT_CARRY[33]) );
   HALF_ADDER HA_8 (.DATA_A (INT_CARRY[26]) , .DATA_B (INT_CARRY[27]) , .SAVE (INT_SUM[43]) , .CARRY (INT_CARRY[35]) );
   FLIPFLOP LA_39 (.DIN (INT_SUM[41]) , .CLK (CLK) , .DOUT (INT_SUM[42]) );
   FLIPFLOP LA_40 (.DIN (INT_SUM[43]) , .CLK (CLK) , .DOUT (INT_SUM[44]) );
   FLIPFLOP LA_41 (.DIN (INT_CARRY[28]) , .CLK (CLK) , .DOUT (INT_CARRY[29]) );
   FULL_ADDER FA_16 (.DATA_A (INT_SUM[42]) , .DATA_B (INT_SUM[44]) , .DATA_C (INT_CARRY[29]) , .SAVE (INT_SUM[45]) , .CARRY (INT_CARRY[30]) );
   FLIPFLOP LA_42 (.DIN (INT_SUM[45]) , .CLK (CLK) , .DOUT (SUM[10]) );
   FLIPFLOP LA_43 (.DIN (INT_CARRY[30]) , .CLK (CLK) , .DOUT (CARRY[10]) );
   FULL_ADDER FA_17 (.DATA_A (SUMMAND[42]) , .DATA_B (SUMMAND[43]) , .DATA_C (SUMMAND[44]) , .SAVE (INT_SUM[46]) , .CARRY (INT_CARRY[38]) );
   FULL_ADDER FA_18 (.DATA_A (SUMMAND[45]) , .DATA_B (SUMMAND[46]) , .DATA_C (SUMMAND[47]) , .SAVE (INT_SUM[47]) , .CARRY (INT_CARRY[39]) );
   FULL_ADDER FA_19 (.DATA_A (INT_SUM[46]) , .DATA_B (INT_SUM[47]) , .DATA_C (INT_CARRY[31]) , .SAVE (INT_SUM[48]) , .CARRY (INT_CARRY[40]) );
   assign INT_SUM[50] = INT_CARRY[32];
   FLIPFLOP LA_44 (.DIN (INT_SUM[48]) , .CLK (CLK) , .DOUT (INT_SUM[49]) );
   FLIPFLOP LA_45 (.DIN (INT_SUM[50]) , .CLK (CLK) , .DOUT (INT_SUM[51]) );
   FLIPFLOP LA_46 (.DIN (INT_CARRY[33]) , .CLK (CLK) , .DOUT (INT_CARRY[34]) );
   FULL_ADDER FA_20 (.DATA_A (INT_SUM[49]) , .DATA_B (INT_SUM[51]) , .DATA_C (INT_CARRY[34]) , .SAVE (INT_SUM[52]) , .CARRY (INT_CARRY[42]) );
   FLIPFLOP LA_47 (.DIN (INT_CARRY[35]) , .CLK (CLK) , .DOUT (INT_CARRY[36]) );
   assign INT_SUM[53] = INT_CARRY[36];
   HALF_ADDER HA_9 (.DATA_A (INT_SUM[52]) , .DATA_B (INT_SUM[53]) , .SAVE (INT_SUM[54]) , .CARRY (INT_CARRY[37]) );
   FLIPFLOP LA_48 (.DIN (INT_SUM[54]) , .CLK (CLK) , .DOUT (SUM[11]) );
   FLIPFLOP LA_49 (.DIN (INT_CARRY[37]) , .CLK (CLK) , .DOUT (CARRY[11]) );
   FULL_ADDER FA_21 (.DATA_A (SUMMAND[48]) , .DATA_B (SUMMAND[49]) , .DATA_C (SUMMAND[50]) , .SAVE (INT_SUM[55]) , .CARRY (INT_CARRY[44]) );
   FULL_ADDER FA_22 (.DATA_A (SUMMAND[51]) , .DATA_B (SUMMAND[52]) , .DATA_C (SUMMAND[53]) , .SAVE (INT_SUM[56]) , .CARRY (INT_CARRY[45]) );
   assign INT_SUM[57] = SUMMAND[54];
   assign INT_SUM[58] = SUMMAND[55];
   FULL_ADDER FA_23 (.DATA_A (INT_SUM[55]) , .DATA_B (INT_SUM[56]) , .DATA_C (INT_SUM[57]) , .SAVE (INT_SUM[59]) , .CARRY (INT_CARRY[46]) );
   FULL_ADDER FA_24 (.DATA_A (INT_SUM[58]) , .DATA_B (INT_CARRY[38]) , .DATA_C (INT_CARRY[39]) , .SAVE (INT_SUM[61]) , .CARRY (INT_CARRY[48]) );
   FLIPFLOP LA_50 (.DIN (INT_SUM[59]) , .CLK (CLK) , .DOUT (INT_SUM[60]) );
   FLIPFLOP LA_51 (.DIN (INT_SUM[61]) , .CLK (CLK) , .DOUT (INT_SUM[62]) );
   FLIPFLOP LA_52 (.DIN (INT_CARRY[40]) , .CLK (CLK) , .DOUT (INT_CARRY[41]) );
   FULL_ADDER FA_25 (.DATA_A (INT_SUM[60]) , .DATA_B (INT_SUM[62]) , .DATA_C (INT_CARRY[41]) , .SAVE (INT_SUM[63]) , .CARRY (INT_CARRY[50]) );
   HALF_ADDER HA_10 (.DATA_A (INT_SUM[63]) , .DATA_B (INT_CARRY[42]) , .SAVE (INT_SUM[64]) , .CARRY (INT_CARRY[43]) );
   FLIPFLOP LA_53 (.DIN (INT_SUM[64]) , .CLK (CLK) , .DOUT (SUM[12]) );
   FLIPFLOP LA_54 (.DIN (INT_CARRY[43]) , .CLK (CLK) , .DOUT (CARRY[12]) );
   FULL_ADDER FA_26 (.DATA_A (SUMMAND[56]) , .DATA_B (SUMMAND[57]) , .DATA_C (SUMMAND[58]) , .SAVE (INT_SUM[65]) , .CARRY (INT_CARRY[52]) );
   FULL_ADDER FA_27 (.DATA_A (SUMMAND[59]) , .DATA_B (SUMMAND[60]) , .DATA_C (SUMMAND[61]) , .SAVE (INT_SUM[66]) , .CARRY (INT_CARRY[53]) );
   assign INT_SUM[67] = SUMMAND[62];
   FULL_ADDER FA_28 (.DATA_A (INT_SUM[65]) , .DATA_B (INT_SUM[66]) , .DATA_C (INT_SUM[67]) , .SAVE (INT_SUM[68]) , .CARRY (INT_CARRY[54]) );
   HALF_ADDER HA_11 (.DATA_A (INT_CARRY[44]) , .DATA_B (INT_CARRY[45]) , .SAVE (INT_SUM[70]) , .CARRY (INT_CARRY[56]) );
   FLIPFLOP LA_55 (.DIN (INT_SUM[68]) , .CLK (CLK) , .DOUT (INT_SUM[69]) );
   FLIPFLOP LA_56 (.DIN (INT_SUM[70]) , .CLK (CLK) , .DOUT (INT_SUM[71]) );
   FLIPFLOP LA_57 (.DIN (INT_CARRY[46]) , .CLK (CLK) , .DOUT (INT_CARRY[47]) );
   FULL_ADDER FA_29 (.DATA_A (INT_SUM[69]) , .DATA_B (INT_SUM[71]) , .DATA_C (INT_CARRY[47]) , .SAVE (INT_SUM[72]) , .CARRY (INT_CARRY[58]) );
   FLIPFLOP LA_58 (.DIN (INT_CARRY[48]) , .CLK (CLK) , .DOUT (INT_CARRY[49]) );
   assign INT_SUM[73] = INT_CARRY[49];
   FULL_ADDER FA_30 (.DATA_A (INT_SUM[72]) , .DATA_B (INT_SUM[73]) , .DATA_C (INT_CARRY[50]) , .SAVE (INT_SUM[74]) , .CARRY (INT_CARRY[51]) );
   FLIPFLOP LA_59 (.DIN (INT_SUM[74]) , .CLK (CLK) , .DOUT (SUM[13]) );
   FLIPFLOP LA_60 (.DIN (INT_CARRY[51]) , .CLK (CLK) , .DOUT (CARRY[13]) );
   FULL_ADDER FA_31 (.DATA_A (SUMMAND[63]) , .DATA_B (SUMMAND[64]) , .DATA_C (SUMMAND[65]) , .SAVE (INT_SUM[75]) , .CARRY (INT_CARRY[60]) );
   FULL_ADDER FA_32 (.DATA_A (SUMMAND[66]) , .DATA_B (SUMMAND[67]) , .DATA_C (SUMMAND[68]) , .SAVE (INT_SUM[76]) , .CARRY (INT_CARRY[61]) );
   FULL_ADDER FA_33 (.DATA_A (SUMMAND[69]) , .DATA_B (SUMMAND[70]) , .DATA_C (SUMMAND[71]) , .SAVE (INT_SUM[77]) , .CARRY (INT_CARRY[62]) );
   FULL_ADDER FA_34 (.DATA_A (INT_SUM[75]) , .DATA_B (INT_SUM[76]) , .DATA_C (INT_SUM[77]) , .SAVE (INT_SUM[78]) , .CARRY (INT_CARRY[63]) );
   HALF_ADDER HA_12 (.DATA_A (INT_CARRY[52]) , .DATA_B (INT_CARRY[53]) , .SAVE (INT_SUM[80]) , .CARRY (INT_CARRY[65]) );
   FLIPFLOP LA_61 (.DIN (INT_SUM[78]) , .CLK (CLK) , .DOUT (INT_SUM[79]) );
   FLIPFLOP LA_62 (.DIN (INT_SUM[80]) , .CLK (CLK) , .DOUT (INT_SUM[81]) );
   FLIPFLOP LA_63 (.DIN (INT_CARRY[54]) , .CLK (CLK) , .DOUT (INT_CARRY[55]) );
   FULL_ADDER FA_35 (.DATA_A (INT_SUM[79]) , .DATA_B (INT_SUM[81]) , .DATA_C (INT_CARRY[55]) , .SAVE (INT_SUM[82]) , .CARRY (INT_CARRY[67]) );
   FLIPFLOP LA_64 (.DIN (INT_CARRY[56]) , .CLK (CLK) , .DOUT (INT_CARRY[57]) );
   assign INT_SUM[83] = INT_CARRY[57];
   FULL_ADDER FA_36 (.DATA_A (INT_SUM[82]) , .DATA_B (INT_SUM[83]) , .DATA_C (INT_CARRY[58]) , .SAVE (INT_SUM[84]) , .CARRY (INT_CARRY[59]) );
   FLIPFLOP LA_65 (.DIN (INT_SUM[84]) , .CLK (CLK) , .DOUT (SUM[14]) );
   FLIPFLOP LA_66 (.DIN (INT_CARRY[59]) , .CLK (CLK) , .DOUT (CARRY[14]) );
   FULL_ADDER FA_37 (.DATA_A (SUMMAND[72]) , .DATA_B (SUMMAND[73]) , .DATA_C (SUMMAND[74]) , .SAVE (INT_SUM[85]) , .CARRY (INT_CARRY[69]) );
   FULL_ADDER FA_38 (.DATA_A (SUMMAND[75]) , .DATA_B (SUMMAND[76]) , .DATA_C (SUMMAND[77]) , .SAVE (INT_SUM[86]) , .CARRY (INT_CARRY[70]) );
   HALF_ADDER HA_13 (.DATA_A (SUMMAND[78]) , .DATA_B (SUMMAND[79]) , .SAVE (INT_SUM[87]) , .CARRY (INT_CARRY[71]) );
   FULL_ADDER FA_39 (.DATA_A (INT_SUM[85]) , .DATA_B (INT_SUM[86]) , .DATA_C (INT_SUM[87]) , .SAVE (INT_SUM[88]) , .CARRY (INT_CARRY[72]) );
   FULL_ADDER FA_40 (.DATA_A (INT_CARRY[60]) , .DATA_B (INT_CARRY[61]) , .DATA_C (INT_CARRY[62]) , .SAVE (INT_SUM[90]) , .CARRY (INT_CARRY[74]) );
   FLIPFLOP LA_67 (.DIN (INT_SUM[88]) , .CLK (CLK) , .DOUT (INT_SUM[89]) );
   FLIPFLOP LA_68 (.DIN (INT_SUM[90]) , .CLK (CLK) , .DOUT (INT_SUM[91]) );
   FLIPFLOP LA_69 (.DIN (INT_CARRY[63]) , .CLK (CLK) , .DOUT (INT_CARRY[64]) );
   FULL_ADDER FA_41 (.DATA_A (INT_SUM[89]) , .DATA_B (INT_SUM[91]) , .DATA_C (INT_CARRY[64]) , .SAVE (INT_SUM[92]) , .CARRY (INT_CARRY[76]) );
   FLIPFLOP LA_70 (.DIN (INT_CARRY[65]) , .CLK (CLK) , .DOUT (INT_CARRY[66]) );
   assign INT_SUM[93] = INT_CARRY[66];
   FULL_ADDER FA_42 (.DATA_A (INT_SUM[92]) , .DATA_B (INT_SUM[93]) , .DATA_C (INT_CARRY[67]) , .SAVE (INT_SUM[94]) , .CARRY (INT_CARRY[68]) );
   FLIPFLOP LA_71 (.DIN (INT_SUM[94]) , .CLK (CLK) , .DOUT (SUM[15]) );
   FLIPFLOP LA_72 (.DIN (INT_CARRY[68]) , .CLK (CLK) , .DOUT (CARRY[15]) );
   FULL_ADDER FA_43 (.DATA_A (SUMMAND[80]) , .DATA_B (SUMMAND[81]) , .DATA_C (SUMMAND[82]) , .SAVE (INT_SUM[95]) , .CARRY (INT_CARRY[78]) );
   FULL_ADDER FA_44 (.DATA_A (SUMMAND[83]) , .DATA_B (SUMMAND[84]) , .DATA_C (SUMMAND[85]) , .SAVE (INT_SUM[96]) , .CARRY (INT_CARRY[79]) );
   HALF_ADDER HA_14 (.DATA_A (SUMMAND[86]) , .DATA_B (SUMMAND[87]) , .SAVE (INT_SUM[97]) , .CARRY (INT_CARRY[80]) );
   FULL_ADDER FA_45 (.DATA_A (INT_SUM[95]) , .DATA_B (INT_SUM[96]) , .DATA_C (INT_SUM[97]) , .SAVE (INT_SUM[98]) , .CARRY (INT_CARRY[81]) );
   FULL_ADDER FA_46 (.DATA_A (INT_CARRY[69]) , .DATA_B (INT_CARRY[70]) , .DATA_C (INT_CARRY[71]) , .SAVE (INT_SUM[100]) , .CARRY (INT_CARRY[83]) );
   FLIPFLOP LA_73 (.DIN (INT_SUM[98]) , .CLK (CLK) , .DOUT (INT_SUM[99]) );
   FLIPFLOP LA_74 (.DIN (INT_SUM[100]) , .CLK (CLK) , .DOUT (INT_SUM[101]) );
   FLIPFLOP LA_75 (.DIN (INT_CARRY[72]) , .CLK (CLK) , .DOUT (INT_CARRY[73]) );
   FULL_ADDER FA_47 (.DATA_A (INT_SUM[99]) , .DATA_B (INT_SUM[101]) , .DATA_C (INT_CARRY[73]) , .SAVE (INT_SUM[102]) , .CARRY (INT_CARRY[85]) );
   FLIPFLOP LA_76 (.DIN (INT_CARRY[74]) , .CLK (CLK) , .DOUT (INT_CARRY[75]) );
   assign INT_SUM[103] = INT_CARRY[75];
   FULL_ADDER FA_48 (.DATA_A (INT_SUM[102]) , .DATA_B (INT_SUM[103]) , .DATA_C (INT_CARRY[76]) , .SAVE (INT_SUM[104]) , .CARRY (INT_CARRY[77]) );
   FLIPFLOP LA_77 (.DIN (INT_SUM[104]) , .CLK (CLK) , .DOUT (SUM[16]) );
   FLIPFLOP LA_78 (.DIN (INT_CARRY[77]) , .CLK (CLK) , .DOUT (CARRY[16]) );
   FULL_ADDER FA_49 (.DATA_A (SUMMAND[88]) , .DATA_B (SUMMAND[89]) , .DATA_C (SUMMAND[90]) , .SAVE (INT_SUM[105]) , .CARRY (INT_CARRY[87]) );
   FULL_ADDER FA_50 (.DATA_A (SUMMAND[91]) , .DATA_B (SUMMAND[92]) , .DATA_C (SUMMAND[93]) , .SAVE (INT_SUM[106]) , .CARRY (INT_CARRY[88]) );
   FULL_ADDER FA_51 (.DATA_A (SUMMAND[94]) , .DATA_B (SUMMAND[95]) , .DATA_C (SUMMAND[96]) , .SAVE (INT_SUM[107]) , .CARRY (INT_CARRY[89]) );
   FULL_ADDER FA_52 (.DATA_A (INT_SUM[105]) , .DATA_B (INT_SUM[106]) , .DATA_C (INT_SUM[107]) , .SAVE (INT_SUM[108]) , .CARRY (INT_CARRY[90]) );
   FULL_ADDER FA_53 (.DATA_A (INT_CARRY[78]) , .DATA_B (INT_CARRY[79]) , .DATA_C (INT_CARRY[80]) , .SAVE (INT_SUM[110]) , .CARRY (INT_CARRY[92]) );
   FLIPFLOP LA_79 (.DIN (INT_SUM[108]) , .CLK (CLK) , .DOUT (INT_SUM[109]) );
   FLIPFLOP LA_80 (.DIN (INT_SUM[110]) , .CLK (CLK) , .DOUT (INT_SUM[111]) );
   FLIPFLOP LA_81 (.DIN (INT_CARRY[81]) , .CLK (CLK) , .DOUT (INT_CARRY[82]) );
   FULL_ADDER FA_54 (.DATA_A (INT_SUM[109]) , .DATA_B (INT_SUM[111]) , .DATA_C (INT_CARRY[82]) , .SAVE (INT_SUM[112]) , .CARRY (INT_CARRY[94]) );
   FLIPFLOP LA_82 (.DIN (INT_CARRY[83]) , .CLK (CLK) , .DOUT (INT_CARRY[84]) );
   assign INT_SUM[113] = INT_CARRY[84];
   FULL_ADDER FA_55 (.DATA_A (INT_SUM[112]) , .DATA_B (INT_SUM[113]) , .DATA_C (INT_CARRY[85]) , .SAVE (INT_SUM[114]) , .CARRY (INT_CARRY[86]) );
   FLIPFLOP LA_83 (.DIN (INT_SUM[114]) , .CLK (CLK) , .DOUT (SUM[17]) );
   FLIPFLOP LA_84 (.DIN (INT_CARRY[86]) , .CLK (CLK) , .DOUT (CARRY[17]) );
   FULL_ADDER FA_56 (.DATA_A (SUMMAND[97]) , .DATA_B (SUMMAND[98]) , .DATA_C (SUMMAND[99]) , .SAVE (INT_SUM[115]) , .CARRY (INT_CARRY[96]) );
   FULL_ADDER FA_57 (.DATA_A (SUMMAND[100]) , .DATA_B (SUMMAND[101]) , .DATA_C (SUMMAND[102]) , .SAVE (INT_SUM[116]) , .CARRY (INT_CARRY[97]) );
   HALF_ADDER HA_15 (.DATA_A (SUMMAND[103]) , .DATA_B (SUMMAND[104]) , .SAVE (INT_SUM[117]) , .CARRY (INT_CARRY[98]) );
   FULL_ADDER FA_58 (.DATA_A (INT_SUM[115]) , .DATA_B (INT_SUM[116]) , .DATA_C (INT_SUM[117]) , .SAVE (INT_SUM[118]) , .CARRY (INT_CARRY[99]) );
   FULL_ADDER FA_59 (.DATA_A (INT_CARRY[87]) , .DATA_B (INT_CARRY[88]) , .DATA_C (INT_CARRY[89]) , .SAVE (INT_SUM[120]) , .CARRY (INT_CARRY[101]) );
   FLIPFLOP LA_85 (.DIN (INT_SUM[118]) , .CLK (CLK) , .DOUT (INT_SUM[119]) );
   FLIPFLOP LA_86 (.DIN (INT_SUM[120]) , .CLK (CLK) , .DOUT (INT_SUM[121]) );
   FLIPFLOP LA_87 (.DIN (INT_CARRY[90]) , .CLK (CLK) , .DOUT (INT_CARRY[91]) );
   FULL_ADDER FA_60 (.DATA_A (INT_SUM[119]) , .DATA_B (INT_SUM[121]) , .DATA_C (INT_CARRY[91]) , .SAVE (INT_SUM[122]) , .CARRY (INT_CARRY[103]) );
   FLIPFLOP LA_88 (.DIN (INT_CARRY[92]) , .CLK (CLK) , .DOUT (INT_CARRY[93]) );
   assign INT_SUM[123] = INT_CARRY[93];
   FULL_ADDER FA_61 (.DATA_A (INT_SUM[122]) , .DATA_B (INT_SUM[123]) , .DATA_C (INT_CARRY[94]) , .SAVE (INT_SUM[124]) , .CARRY (INT_CARRY[95]) );
   FLIPFLOP LA_89 (.DIN (INT_SUM[124]) , .CLK (CLK) , .DOUT (SUM[18]) );
   FLIPFLOP LA_90 (.DIN (INT_CARRY[95]) , .CLK (CLK) , .DOUT (CARRY[18]) );
   FULL_ADDER FA_62 (.DATA_A (SUMMAND[105]) , .DATA_B (SUMMAND[106]) , .DATA_C (SUMMAND[107]) , .SAVE (INT_SUM[125]) , .CARRY (INT_CARRY[105]) );
   FULL_ADDER FA_63 (.DATA_A (SUMMAND[108]) , .DATA_B (SUMMAND[109]) , .DATA_C (SUMMAND[110]) , .SAVE (INT_SUM[126]) , .CARRY (INT_CARRY[106]) );
   assign INT_SUM[127] = SUMMAND[111];
   FULL_ADDER FA_64 (.DATA_A (INT_SUM[125]) , .DATA_B (INT_SUM[126]) , .DATA_C (INT_SUM[127]) , .SAVE (INT_SUM[128]) , .CARRY (INT_CARRY[107]) );
   FULL_ADDER FA_65 (.DATA_A (INT_CARRY[96]) , .DATA_B (INT_CARRY[97]) , .DATA_C (INT_CARRY[98]) , .SAVE (INT_SUM[130]) , .CARRY (INT_CARRY[109]) );
   FLIPFLOP LA_91 (.DIN (INT_SUM[128]) , .CLK (CLK) , .DOUT (INT_SUM[129]) );
   FLIPFLOP LA_92 (.DIN (INT_SUM[130]) , .CLK (CLK) , .DOUT (INT_SUM[131]) );
   FLIPFLOP LA_93 (.DIN (INT_CARRY[99]) , .CLK (CLK) , .DOUT (INT_CARRY[100]) );
   FULL_ADDER FA_66 (.DATA_A (INT_SUM[129]) , .DATA_B (INT_SUM[131]) , .DATA_C (INT_CARRY[100]) , .SAVE (INT_SUM[132]) , .CARRY (INT_CARRY[111]) );
   FLIPFLOP LA_94 (.DIN (INT_CARRY[101]) , .CLK (CLK) , .DOUT (INT_CARRY[102]) );
   assign INT_SUM[133] = INT_CARRY[102];
   FULL_ADDER FA_67 (.DATA_A (INT_SUM[132]) , .DATA_B (INT_SUM[133]) , .DATA_C (INT_CARRY[103]) , .SAVE (INT_SUM[134]) , .CARRY (INT_CARRY[104]) );
   FLIPFLOP LA_95 (.DIN (INT_SUM[134]) , .CLK (CLK) , .DOUT (SUM[19]) );
   FLIPFLOP LA_96 (.DIN (INT_CARRY[104]) , .CLK (CLK) , .DOUT (CARRY[19]) );
   FULL_ADDER FA_68 (.DATA_A (SUMMAND[112]) , .DATA_B (SUMMAND[113]) , .DATA_C (SUMMAND[114]) , .SAVE (INT_SUM[135]) , .CARRY (INT_CARRY[113]) );
   FULL_ADDER FA_69 (.DATA_A (SUMMAND[115]) , .DATA_B (SUMMAND[116]) , .DATA_C (SUMMAND[117]) , .SAVE (INT_SUM[136]) , .CARRY (INT_CARRY[114]) );
   assign INT_SUM[137] = SUMMAND[118];
   FULL_ADDER FA_70 (.DATA_A (INT_SUM[135]) , .DATA_B (INT_SUM[136]) , .DATA_C (INT_SUM[137]) , .SAVE (INT_SUM[138]) , .CARRY (INT_CARRY[115]) );
   HALF_ADDER HA_16 (.DATA_A (INT_CARRY[105]) , .DATA_B (INT_CARRY[106]) , .SAVE (INT_SUM[140]) , .CARRY (INT_CARRY[117]) );
   FLIPFLOP LA_97 (.DIN (INT_SUM[138]) , .CLK (CLK) , .DOUT (INT_SUM[139]) );
   FLIPFLOP LA_98 (.DIN (INT_SUM[140]) , .CLK (CLK) , .DOUT (INT_SUM[141]) );
   FLIPFLOP LA_99 (.DIN (INT_CARRY[107]) , .CLK (CLK) , .DOUT (INT_CARRY[108]) );
   FULL_ADDER FA_71 (.DATA_A (INT_SUM[139]) , .DATA_B (INT_SUM[141]) , .DATA_C (INT_CARRY[108]) , .SAVE (INT_SUM[142]) , .CARRY (INT_CARRY[119]) );
   FLIPFLOP LA_100 (.DIN (INT_CARRY[109]) , .CLK (CLK) , .DOUT (INT_CARRY[110]) );
   assign INT_SUM[143] = INT_CARRY[110];
   FULL_ADDER FA_72 (.DATA_A (INT_SUM[142]) , .DATA_B (INT_SUM[143]) , .DATA_C (INT_CARRY[111]) , .SAVE (INT_SUM[144]) , .CARRY (INT_CARRY[112]) );
   FLIPFLOP LA_101 (.DIN (INT_SUM[144]) , .CLK (CLK) , .DOUT (SUM[20]) );
   FLIPFLOP LA_102 (.DIN (INT_CARRY[112]) , .CLK (CLK) , .DOUT (CARRY[20]) );
   FULL_ADDER FA_73 (.DATA_A (SUMMAND[119]) , .DATA_B (SUMMAND[120]) , .DATA_C (SUMMAND[121]) , .SAVE (INT_SUM[145]) , .CARRY (INT_CARRY[121]) );
   FULL_ADDER FA_74 (.DATA_A (SUMMAND[122]) , .DATA_B (SUMMAND[123]) , .DATA_C (SUMMAND[124]) , .SAVE (INT_SUM[146]) , .CARRY (INT_CARRY[122]) );
   FULL_ADDER FA_75 (.DATA_A (INT_SUM[145]) , .DATA_B (INT_SUM[146]) , .DATA_C (INT_CARRY[113]) , .SAVE (INT_SUM[147]) , .CARRY (INT_CARRY[123]) );
   assign INT_SUM[149] = INT_CARRY[114];
   FLIPFLOP LA_103 (.DIN (INT_SUM[147]) , .CLK (CLK) , .DOUT (INT_SUM[148]) );
   FLIPFLOP LA_104 (.DIN (INT_SUM[149]) , .CLK (CLK) , .DOUT (INT_SUM[150]) );
   FLIPFLOP LA_105 (.DIN (INT_CARRY[115]) , .CLK (CLK) , .DOUT (INT_CARRY[116]) );
   FULL_ADDER FA_76 (.DATA_A (INT_SUM[148]) , .DATA_B (INT_SUM[150]) , .DATA_C (INT_CARRY[116]) , .SAVE (INT_SUM[151]) , .CARRY (INT_CARRY[125]) );
   FLIPFLOP LA_106 (.DIN (INT_CARRY[117]) , .CLK (CLK) , .DOUT (INT_CARRY[118]) );
   assign INT_SUM[152] = INT_CARRY[118];
   FULL_ADDER FA_77 (.DATA_A (INT_SUM[151]) , .DATA_B (INT_SUM[152]) , .DATA_C (INT_CARRY[119]) , .SAVE (INT_SUM[153]) , .CARRY (INT_CARRY[120]) );
   FLIPFLOP LA_107 (.DIN (INT_SUM[153]) , .CLK (CLK) , .DOUT (SUM[21]) );
   FLIPFLOP LA_108 (.DIN (INT_CARRY[120]) , .CLK (CLK) , .DOUT (CARRY[21]) );
   FULL_ADDER FA_78 (.DATA_A (SUMMAND[125]) , .DATA_B (SUMMAND[126]) , .DATA_C (SUMMAND[127]) , .SAVE (INT_SUM[154]) , .CARRY (INT_CARRY[127]) );
   FULL_ADDER FA_79 (.DATA_A (SUMMAND[128]) , .DATA_B (SUMMAND[129]) , .DATA_C (SUMMAND[130]) , .SAVE (INT_SUM[155]) , .CARRY (INT_CARRY[128]) );
   FULL_ADDER FA_80 (.DATA_A (INT_SUM[154]) , .DATA_B (INT_SUM[155]) , .DATA_C (INT_CARRY[121]) , .SAVE (INT_SUM[156]) , .CARRY (INT_CARRY[129]) );
   assign INT_SUM[158] = INT_CARRY[122];
   FLIPFLOP LA_109 (.DIN (INT_SUM[156]) , .CLK (CLK) , .DOUT (INT_SUM[157]) );
   FLIPFLOP LA_110 (.DIN (INT_SUM[158]) , .CLK (CLK) , .DOUT (INT_SUM[159]) );
   FLIPFLOP LA_111 (.DIN (INT_CARRY[123]) , .CLK (CLK) , .DOUT (INT_CARRY[124]) );
   FULL_ADDER FA_81 (.DATA_A (INT_SUM[157]) , .DATA_B (INT_SUM[159]) , .DATA_C (INT_CARRY[124]) , .SAVE (INT_SUM[160]) , .CARRY (INT_CARRY[131]) );
   HALF_ADDER HA_17 (.DATA_A (INT_SUM[160]) , .DATA_B (INT_CARRY[125]) , .SAVE (INT_SUM[161]) , .CARRY (INT_CARRY[126]) );
   FLIPFLOP LA_112 (.DIN (INT_SUM[161]) , .CLK (CLK) , .DOUT (SUM[22]) );
   FLIPFLOP LA_113 (.DIN (INT_CARRY[126]) , .CLK (CLK) , .DOUT (CARRY[22]) );
   FULL_ADDER FA_82 (.DATA_A (SUMMAND[131]) , .DATA_B (SUMMAND[132]) , .DATA_C (SUMMAND[133]) , .SAVE (INT_SUM[162]) , .CARRY (INT_CARRY[133]) );
   HALF_ADDER HA_18 (.DATA_A (SUMMAND[134]) , .DATA_B (SUMMAND[135]) , .SAVE (INT_SUM[163]) , .CARRY (INT_CARRY[134]) );
   FULL_ADDER FA_83 (.DATA_A (INT_SUM[162]) , .DATA_B (INT_SUM[163]) , .DATA_C (INT_CARRY[127]) , .SAVE (INT_SUM[164]) , .CARRY (INT_CARRY[135]) );
   assign INT_SUM[166] = INT_CARRY[128];
   FLIPFLOP LA_114 (.DIN (INT_SUM[164]) , .CLK (CLK) , .DOUT (INT_SUM[165]) );
   FLIPFLOP LA_115 (.DIN (INT_SUM[166]) , .CLK (CLK) , .DOUT (INT_SUM[167]) );
   FLIPFLOP LA_116 (.DIN (INT_CARRY[129]) , .CLK (CLK) , .DOUT (INT_CARRY[130]) );
   FULL_ADDER FA_84 (.DATA_A (INT_SUM[165]) , .DATA_B (INT_SUM[167]) , .DATA_C (INT_CARRY[130]) , .SAVE (INT_SUM[168]) , .CARRY (INT_CARRY[137]) );
   HALF_ADDER HA_19 (.DATA_A (INT_SUM[168]) , .DATA_B (INT_CARRY[131]) , .SAVE (INT_SUM[169]) , .CARRY (INT_CARRY[132]) );
   FLIPFLOP LA_117 (.DIN (INT_SUM[169]) , .CLK (CLK) , .DOUT (SUM[23]) );
   FLIPFLOP LA_118 (.DIN (INT_CARRY[132]) , .CLK (CLK) , .DOUT (CARRY[23]) );
   FULL_ADDER FA_85 (.DATA_A (SUMMAND[136]) , .DATA_B (SUMMAND[137]) , .DATA_C (SUMMAND[138]) , .SAVE (INT_SUM[170]) , .CARRY (INT_CARRY[139]) );
   HALF_ADDER HA_20 (.DATA_A (SUMMAND[139]) , .DATA_B (SUMMAND[140]) , .SAVE (INT_SUM[171]) , .CARRY (INT_CARRY[140]) );
   FULL_ADDER FA_86 (.DATA_A (INT_SUM[170]) , .DATA_B (INT_SUM[171]) , .DATA_C (INT_CARRY[133]) , .SAVE (INT_SUM[172]) , .CARRY (INT_CARRY[141]) );
   assign INT_SUM[174] = INT_CARRY[134];
   FLIPFLOP LA_119 (.DIN (INT_SUM[172]) , .CLK (CLK) , .DOUT (INT_SUM[173]) );
   FLIPFLOP LA_120 (.DIN (INT_SUM[174]) , .CLK (CLK) , .DOUT (INT_SUM[175]) );
   FLIPFLOP LA_121 (.DIN (INT_CARRY[135]) , .CLK (CLK) , .DOUT (INT_CARRY[136]) );
   FULL_ADDER FA_87 (.DATA_A (INT_SUM[173]) , .DATA_B (INT_SUM[175]) , .DATA_C (INT_CARRY[136]) , .SAVE (INT_SUM[176]) , .CARRY (INT_CARRY[143]) );
   HALF_ADDER HA_21 (.DATA_A (INT_SUM[176]) , .DATA_B (INT_CARRY[137]) , .SAVE (INT_SUM[177]) , .CARRY (INT_CARRY[138]) );
   FLIPFLOP LA_122 (.DIN (INT_SUM[177]) , .CLK (CLK) , .DOUT (SUM[24]) );
   FLIPFLOP LA_123 (.DIN (INT_CARRY[138]) , .CLK (CLK) , .DOUT (CARRY[24]) );
   FULL_ADDER FA_88 (.DATA_A (SUMMAND[141]) , .DATA_B (SUMMAND[142]) , .DATA_C (SUMMAND[143]) , .SAVE (INT_SUM[178]) , .CARRY (INT_CARRY[145]) );
   FULL_ADDER FA_89 (.DATA_A (SUMMAND[144]) , .DATA_B (INT_CARRY[139]) , .DATA_C (INT_CARRY[140]) , .SAVE (INT_SUM[180]) , .CARRY (INT_CARRY[147]) );
   FLIPFLOP LA_124 (.DIN (INT_SUM[178]) , .CLK (CLK) , .DOUT (INT_SUM[179]) );
   FLIPFLOP LA_125 (.DIN (INT_SUM[180]) , .CLK (CLK) , .DOUT (INT_SUM[181]) );
   FLIPFLOP LA_126 (.DIN (INT_CARRY[141]) , .CLK (CLK) , .DOUT (INT_CARRY[142]) );
   FULL_ADDER FA_90 (.DATA_A (INT_SUM[179]) , .DATA_B (INT_SUM[181]) , .DATA_C (INT_CARRY[142]) , .SAVE (INT_SUM[182]) , .CARRY (INT_CARRY[149]) );
   HALF_ADDER HA_22 (.DATA_A (INT_SUM[182]) , .DATA_B (INT_CARRY[143]) , .SAVE (INT_SUM[183]) , .CARRY (INT_CARRY[144]) );
   FLIPFLOP LA_127 (.DIN (INT_SUM[183]) , .CLK (CLK) , .DOUT (SUM[25]) );
   FLIPFLOP LA_128 (.DIN (INT_CARRY[144]) , .CLK (CLK) , .DOUT (CARRY[25]) );
   FULL_ADDER FA_91 (.DATA_A (SUMMAND[145]) , .DATA_B (SUMMAND[146]) , .DATA_C (SUMMAND[147]) , .SAVE (INT_SUM[184]) , .CARRY (INT_CARRY[151]) );
   assign INT_SUM[186] = SUMMAND[148];
   FLIPFLOP LA_129 (.DIN (INT_SUM[184]) , .CLK (CLK) , .DOUT (INT_SUM[185]) );
   FLIPFLOP LA_130 (.DIN (INT_SUM[186]) , .CLK (CLK) , .DOUT (INT_SUM[187]) );
   FLIPFLOP LA_131 (.DIN (INT_CARRY[145]) , .CLK (CLK) , .DOUT (INT_CARRY[146]) );
   FULL_ADDER FA_92 (.DATA_A (INT_SUM[185]) , .DATA_B (INT_SUM[187]) , .DATA_C (INT_CARRY[146]) , .SAVE (INT_SUM[188]) , .CARRY (INT_CARRY[153]) );
   FLIPFLOP LA_132 (.DIN (INT_CARRY[147]) , .CLK (CLK) , .DOUT (INT_CARRY[148]) );
   assign INT_SUM[189] = INT_CARRY[148];
   FULL_ADDER FA_93 (.DATA_A (INT_SUM[188]) , .DATA_B (INT_SUM[189]) , .DATA_C (INT_CARRY[149]) , .SAVE (INT_SUM[190]) , .CARRY (INT_CARRY[150]) );
   FLIPFLOP LA_133 (.DIN (INT_SUM[190]) , .CLK (CLK) , .DOUT (SUM[26]) );
   FLIPFLOP LA_134 (.DIN (INT_CARRY[150]) , .CLK (CLK) , .DOUT (CARRY[26]) );
   FULL_ADDER FA_94 (.DATA_A (SUMMAND[149]) , .DATA_B (SUMMAND[150]) , .DATA_C (SUMMAND[151]) , .SAVE (INT_SUM[191]) , .CARRY (INT_CARRY[155]) );
   FLIPFLOP LA_135 (.DIN (INT_SUM[191]) , .CLK (CLK) , .DOUT (INT_SUM[192]) );
   assign INT_SUM[193] = INT_SUM[192];
   FLIPFLOP LA_136 (.DIN (INT_CARRY[151]) , .CLK (CLK) , .DOUT (INT_CARRY[152]) );
   assign INT_SUM[194] = INT_CARRY[152];
   FULL_ADDER FA_95 (.DATA_A (INT_SUM[193]) , .DATA_B (INT_SUM[194]) , .DATA_C (INT_CARRY[153]) , .SAVE (INT_SUM[195]) , .CARRY (INT_CARRY[154]) );
   FLIPFLOP LA_137 (.DIN (INT_SUM[195]) , .CLK (CLK) , .DOUT (SUM[27]) );
   FLIPFLOP LA_138 (.DIN (INT_CARRY[154]) , .CLK (CLK) , .DOUT (CARRY[27]) );
   FLIPFLOP LA_139 (.DIN (SUMMAND[152]) , .CLK (CLK) , .DOUT (LATCHED_PP[0]) );
   FLIPFLOP LA_140 (.DIN (SUMMAND[153]) , .CLK (CLK) , .DOUT (LATCHED_PP[1]) );
   FLIPFLOP LA_141 (.DIN (SUMMAND[154]) , .CLK (CLK) , .DOUT (LATCHED_PP[2]) );
   FULL_ADDER FA_96 (.DATA_A (LATCHED_PP[0]) , .DATA_B (LATCHED_PP[1]) , .DATA_C (LATCHED_PP[2]) , .SAVE (INT_SUM[196]) , .CARRY (INT_CARRY[158]) );
   FLIPFLOP LA_142 (.DIN (INT_CARRY[155]) , .CLK (CLK) , .DOUT (INT_CARRY[156]) );
   assign INT_SUM[197] = INT_CARRY[156];
   HALF_ADDER HA_23 (.DATA_A (INT_SUM[196]) , .DATA_B (INT_SUM[197]) , .SAVE (INT_SUM[198]) , .CARRY (INT_CARRY[157]) );
   FLIPFLOP LA_143 (.DIN (INT_SUM[198]) , .CLK (CLK) , .DOUT (SUM[28]) );
   FLIPFLOP LA_144 (.DIN (INT_CARRY[157]) , .CLK (CLK) , .DOUT (CARRY[28]) );
   FLIPFLOP LA_145 (.DIN (SUMMAND[155]) , .CLK (CLK) , .DOUT (LATCHED_PP[3]) );
   assign INT_SUM[199] = LATCHED_PP[3];
   FLIPFLOP LA_146 (.DIN (SUMMAND[156]) , .CLK (CLK) , .DOUT (LATCHED_PP[4]) );
   assign INT_SUM[200] = LATCHED_PP[4];
   FULL_ADDER FA_97 (.DATA_A (INT_SUM[199]) , .DATA_B (INT_SUM[200]) , .DATA_C (INT_CARRY[158]) , .SAVE (INT_SUM[201]) , .CARRY (INT_CARRY[159]) );
   FLIPFLOP LA_147 (.DIN (INT_SUM[201]) , .CLK (CLK) , .DOUT (SUM[29]) );
   FLIPFLOP LA_148 (.DIN (INT_CARRY[159]) , .CLK (CLK) , .DOUT (CARRY[29]) );
   FLIPFLOP LA_149 (.DIN (SUMMAND[157]) , .CLK (CLK) , .DOUT (LATCHED_PP[5]) );
   FLIPFLOP LA_150 (.DIN (SUMMAND[158]) , .CLK (CLK) , .DOUT (LATCHED_PP[6]) );
   HALF_ADDER HA_24 (.DATA_A (LATCHED_PP[5]) , .DATA_B (LATCHED_PP[6]) , .SAVE (INT_SUM[202]) , .CARRY (INT_CARRY[160]) );
   FLIPFLOP LA_151 (.DIN (INT_SUM[202]) , .CLK (CLK) , .DOUT (SUM[30]) );
   FLIPFLOP LA_152 (.DIN (INT_CARRY[160]) , .CLK (CLK) , .DOUT (CARRY[30]) );
   FLIPFLOP LA_153 (.DIN (SUMMAND[159]) , .CLK (CLK) , .DOUT (LATCHED_PP[7]) );
   assign INT_SUM[203] = LATCHED_PP[7];
   FLIPFLOP LA_154 (.DIN (INT_SUM[203]) , .CLK (CLK) , .DOUT (SUM[31]) );
endmodule


module MULTIPLIER_17_16 ( MULTIPLICAND, MULTIPLIER, CLK, PHI, CLR, RESULT );
input  [0:16] MULTIPLICAND;
input  [0:15] MULTIPLIER;
input  CLK;
input  PHI;
input  CLR;
output [0:63] RESULT;
   wire [0:64] C1;
   wire [0:63] S1;
   wire [0:63] RESULT1,RESULT2,RESULT3;
   wire [0:159] PPBIT;
   wire [0:64] INT_CARRY;
   wire [0:63] INT_SUM;
   wire LOGIC_ZERO;
   assign LOGIC_ZERO = 0;
   BOOTHCODER_17_16 B (.OPA(MULTIPLICAND[0:16]) , .OPB(MULTIPLIER[0:15]) , .CLK (CLK) , .SUMMAND(PPBIT[0:159]) );
   WALLACE_17_16 W (.SUMMAND(PPBIT[0:159]) , .CLK (CLK) , .CARRY(INT_CARRY[1:31]) , .SUM(INT_SUM[0:31]) );
   assign INT_CARRY[0] = LOGIC_ZERO;
   DBLCADDER_64_64 D (.OPA(S1[0:63]) , .OPB(C1[0:63]) , .CIN (LOGIC_ZERO) , .CLK (CLK) , .PHI (PHI) , .SUM(RESULT1[0:63]) );
   assign C1[0] = LOGIC_ZERO;
   FULL_ADDER U0_1 (RESULT3[0] , INT_CARRY[0] , INT_SUM[0] , S1[0] , C1[1] );
   CLRAND2 U0_2 (RESULT1[0] , CLR , RESULT2[0] );
   FLIPFLOP U0_3 (RESULT2[0] , CLK , RESULT3[0] );
   assign RESULT[0] = RESULT3[0];
   FULL_ADDER U1_1 (RESULT3[1] , INT_CARRY[1] , INT_SUM[1] , S1[1] , C1[2] );
   CLRAND2 U1_2 (RESULT1[1] , CLR , RESULT2[1] );
   FLIPFLOP U1_3 (RESULT2[1] , CLK , RESULT3[1] );
   assign RESULT[1] = RESULT3[1];
   FULL_ADDER U2_1 (RESULT3[2] , INT_CARRY[2] , INT_SUM[2] , S1[2] , C1[3] );
   CLRAND2 U2_2 (RESULT1[2] , CLR , RESULT2[2] );
   FLIPFLOP U2_3 (RESULT2[2] , CLK , RESULT3[2] );
   assign RESULT[2] = RESULT3[2];
   FULL_ADDER U3_1 (RESULT3[3] , INT_CARRY[3] , INT_SUM[3] , S1[3] , C1[4] );
   CLRAND2 U3_2 (RESULT1[3] , CLR , RESULT2[3] );
   FLIPFLOP U3_3 (RESULT2[3] , CLK , RESULT3[3] );
   assign RESULT[3] = RESULT3[3];
   FULL_ADDER U4_1 (RESULT3[4] , INT_CARRY[4] , INT_SUM[4] , S1[4] , C1[5] );
   CLRAND2 U4_2 (RESULT1[4] , CLR , RESULT2[4] );
   FLIPFLOP U4_3 (RESULT2[4] , CLK , RESULT3[4] );
   assign RESULT[4] = RESULT3[4];
   FULL_ADDER U5_1 (RESULT3[5] , INT_CARRY[5] , INT_SUM[5] , S1[5] , C1[6] );
   CLRAND2 U5_2 (RESULT1[5] , CLR , RESULT2[5] );
   FLIPFLOP U5_3 (RESULT2[5] , CLK , RESULT3[5] );
   assign RESULT[5] = RESULT3[5];
   FULL_ADDER U6_1 (RESULT3[6] , INT_CARRY[6] , INT_SUM[6] , S1[6] , C1[7] );
   CLRAND2 U6_2 (RESULT1[6] , CLR , RESULT2[6] );
   FLIPFLOP U6_3 (RESULT2[6] , CLK , RESULT3[6] );
   assign RESULT[6] = RESULT3[6];
   FULL_ADDER U7_1 (RESULT3[7] , INT_CARRY[7] , INT_SUM[7] , S1[7] , C1[8] );
   CLRAND2 U7_2 (RESULT1[7] , CLR , RESULT2[7] );
   FLIPFLOP U7_3 (RESULT2[7] , CLK , RESULT3[7] );
   assign RESULT[7] = RESULT3[7];
   FULL_ADDER U8_1 (RESULT3[8] , INT_CARRY[8] , INT_SUM[8] , S1[8] , C1[9] );
   CLRAND2 U8_2 (RESULT1[8] , CLR , RESULT2[8] );
   FLIPFLOP U8_3 (RESULT2[8] , CLK , RESULT3[8] );
   assign RESULT[8] = RESULT3[8];
   FULL_ADDER U9_1 (RESULT3[9] , INT_CARRY[9] , INT_SUM[9] , S1[9] , C1[10] );
   CLRAND2 U9_2 (RESULT1[9] , CLR , RESULT2[9] );
   FLIPFLOP U9_3 (RESULT2[9] , CLK , RESULT3[9] );
   assign RESULT[9] = RESULT3[9];
   FULL_ADDER U10_1 (RESULT3[10] , INT_CARRY[10] , INT_SUM[10] , S1[10] , C1[11] );
   CLRAND2 U10_2 (RESULT1[10] , CLR , RESULT2[10] );
   FLIPFLOP U10_3 (RESULT2[10] , CLK , RESULT3[10] );
   assign RESULT[10] = RESULT3[10];
   FULL_ADDER U11_1 (RESULT3[11] , INT_CARRY[11] , INT_SUM[11] , S1[11] , C1[12] );
   CLRAND2 U11_2 (RESULT1[11] , CLR , RESULT2[11] );
   FLIPFLOP U11_3 (RESULT2[11] , CLK , RESULT3[11] );
   assign RESULT[11] = RESULT3[11];
   FULL_ADDER U12_1 (RESULT3[12] , INT_CARRY[12] , INT_SUM[12] , S1[12] , C1[13] );
   CLRAND2 U12_2 (RESULT1[12] , CLR , RESULT2[12] );
   FLIPFLOP U12_3 (RESULT2[12] , CLK , RESULT3[12] );
   assign RESULT[12] = RESULT3[12];
   FULL_ADDER U13_1 (RESULT3[13] , INT_CARRY[13] , INT_SUM[13] , S1[13] , C1[14] );
   CLRAND2 U13_2 (RESULT1[13] , CLR , RESULT2[13] );
   FLIPFLOP U13_3 (RESULT2[13] , CLK , RESULT3[13] );
   assign RESULT[13] = RESULT3[13];
   FULL_ADDER U14_1 (RESULT3[14] , INT_CARRY[14] , INT_SUM[14] , S1[14] , C1[15] );
   CLRAND2 U14_2 (RESULT1[14] , CLR , RESULT2[14] );
   FLIPFLOP U14_3 (RESULT2[14] , CLK , RESULT3[14] );
   assign RESULT[14] = RESULT3[14];
   FULL_ADDER U15_1 (RESULT3[15] , INT_CARRY[15] , INT_SUM[15] , S1[15] , C1[16] );
   CLRAND2 U15_2 (RESULT1[15] , CLR , RESULT2[15] );
   FLIPFLOP U15_3 (RESULT2[15] , CLK , RESULT3[15] );
   assign RESULT[15] = RESULT3[15];
   FULL_ADDER U16_1 (RESULT3[16] , INT_CARRY[16] , INT_SUM[16] , S1[16] , C1[17] );
   CLRAND2 U16_2 (RESULT1[16] , CLR , RESULT2[16] );
   FLIPFLOP U16_3 (RESULT2[16] , CLK , RESULT3[16] );
   assign RESULT[16] = RESULT3[16];
   FULL_ADDER U17_1 (RESULT3[17] , INT_CARRY[17] , INT_SUM[17] , S1[17] , C1[18] );
   CLRAND2 U17_2 (RESULT1[17] , CLR , RESULT2[17] );
   FLIPFLOP U17_3 (RESULT2[17] , CLK , RESULT3[17] );
   assign RESULT[17] = RESULT3[17];
   FULL_ADDER U18_1 (RESULT3[18] , INT_CARRY[18] , INT_SUM[18] , S1[18] , C1[19] );
   CLRAND2 U18_2 (RESULT1[18] , CLR , RESULT2[18] );
   FLIPFLOP U18_3 (RESULT2[18] , CLK , RESULT3[18] );
   assign RESULT[18] = RESULT3[18];
   FULL_ADDER U19_1 (RESULT3[19] , INT_CARRY[19] , INT_SUM[19] , S1[19] , C1[20] );
   CLRAND2 U19_2 (RESULT1[19] , CLR , RESULT2[19] );
   FLIPFLOP U19_3 (RESULT2[19] , CLK , RESULT3[19] );
   assign RESULT[19] = RESULT3[19];
   FULL_ADDER U20_1 (RESULT3[20] , INT_CARRY[20] , INT_SUM[20] , S1[20] , C1[21] );
   CLRAND2 U20_2 (RESULT1[20] , CLR , RESULT2[20] );
   FLIPFLOP U20_3 (RESULT2[20] , CLK , RESULT3[20] );
   assign RESULT[20] = RESULT3[20];
   FULL_ADDER U21_1 (RESULT3[21] , INT_CARRY[21] , INT_SUM[21] , S1[21] , C1[22] );
   CLRAND2 U21_2 (RESULT1[21] , CLR , RESULT2[21] );
   FLIPFLOP U21_3 (RESULT2[21] , CLK , RESULT3[21] );
   assign RESULT[21] = RESULT3[21];
   FULL_ADDER U22_1 (RESULT3[22] , INT_CARRY[22] , INT_SUM[22] , S1[22] , C1[23] );
   CLRAND2 U22_2 (RESULT1[22] , CLR , RESULT2[22] );
   FLIPFLOP U22_3 (RESULT2[22] , CLK , RESULT3[22] );
   assign RESULT[22] = RESULT3[22];
   FULL_ADDER U23_1 (RESULT3[23] , INT_CARRY[23] , INT_SUM[23] , S1[23] , C1[24] );
   CLRAND2 U23_2 (RESULT1[23] , CLR , RESULT2[23] );
   FLIPFLOP U23_3 (RESULT2[23] , CLK , RESULT3[23] );
   assign RESULT[23] = RESULT3[23];
   FULL_ADDER U24_1 (RESULT3[24] , INT_CARRY[24] , INT_SUM[24] , S1[24] , C1[25] );
   CLRAND2 U24_2 (RESULT1[24] , CLR , RESULT2[24] );
   FLIPFLOP U24_3 (RESULT2[24] , CLK , RESULT3[24] );
   assign RESULT[24] = RESULT3[24];
   FULL_ADDER U25_1 (RESULT3[25] , INT_CARRY[25] , INT_SUM[25] , S1[25] , C1[26] );
   CLRAND2 U25_2 (RESULT1[25] , CLR , RESULT2[25] );
   FLIPFLOP U25_3 (RESULT2[25] , CLK , RESULT3[25] );
   assign RESULT[25] = RESULT3[25];
   FULL_ADDER U26_1 (RESULT3[26] , INT_CARRY[26] , INT_SUM[26] , S1[26] , C1[27] );
   CLRAND2 U26_2 (RESULT1[26] , CLR , RESULT2[26] );
   FLIPFLOP U26_3 (RESULT2[26] , CLK , RESULT3[26] );
   assign RESULT[26] = RESULT3[26];
   FULL_ADDER U27_1 (RESULT3[27] , INT_CARRY[27] , INT_SUM[27] , S1[27] , C1[28] );
   CLRAND2 U27_2 (RESULT1[27] , CLR , RESULT2[27] );
   FLIPFLOP U27_3 (RESULT2[27] , CLK , RESULT3[27] );
   assign RESULT[27] = RESULT3[27];
   FULL_ADDER U28_1 (RESULT3[28] , INT_CARRY[28] , INT_SUM[28] , S1[28] , C1[29] );
   CLRAND2 U28_2 (RESULT1[28] , CLR , RESULT2[28] );
   FLIPFLOP U28_3 (RESULT2[28] , CLK , RESULT3[28] );
   assign RESULT[28] = RESULT3[28];
   FULL_ADDER U29_1 (RESULT3[29] , INT_CARRY[29] , INT_SUM[29] , S1[29] , C1[30] );
   CLRAND2 U29_2 (RESULT1[29] , CLR , RESULT2[29] );
   FLIPFLOP U29_3 (RESULT2[29] , CLK , RESULT3[29] );
   assign RESULT[29] = RESULT3[29];
   FULL_ADDER U30_1 (RESULT3[30] , INT_CARRY[30] , INT_SUM[30] , S1[30] , C1[31] );
   CLRAND2 U30_2 (RESULT1[30] , CLR , RESULT2[30] );
   FLIPFLOP U30_3 (RESULT2[30] , CLK , RESULT3[30] );
   assign RESULT[30] = RESULT3[30];
   FULL_ADDER U31_1 (RESULT3[31] , INT_CARRY[31] , INT_SUM[31] , S1[31] , C1[32] );
   CLRAND2 U31_2 (RESULT1[31] , CLR , RESULT2[31] );
   FLIPFLOP U31_3 (RESULT2[31] , CLK , RESULT3[31] );
   assign RESULT[31] = RESULT3[31];
   FULL_ADDER U32_1 (RESULT3[32] , INT_CARRY[32] , INT_SUM[32] , S1[32] , C1[33] );
   CLRAND2 U32_2 (RESULT1[32] , CLR , RESULT2[32] );
   FLIPFLOP U32_3 (RESULT2[32] , CLK , RESULT3[32] );
   assign RESULT[32] = RESULT3[32];
   FULL_ADDER U33_1 (RESULT3[33] , INT_CARRY[32] , INT_SUM[32] , S1[33] , C1[34] );
   CLRAND2 U33_2 (RESULT1[33] , CLR , RESULT2[33] );
   FLIPFLOP U33_3 (RESULT2[33] , CLK , RESULT3[33] );
   assign RESULT[33] = RESULT3[33];
   FULL_ADDER U34_1 (RESULT3[34] , INT_CARRY[32] , INT_SUM[32] , S1[34] , C1[35] );
   CLRAND2 U34_2 (RESULT1[34] , CLR , RESULT2[34] );
   FLIPFLOP U34_3 (RESULT2[34] , CLK , RESULT3[34] );
   assign RESULT[34] = RESULT3[34];
   FULL_ADDER U35_1 (RESULT3[35] , INT_CARRY[32] , INT_SUM[32] , S1[35] , C1[36] );
   CLRAND2 U35_2 (RESULT1[35] , CLR , RESULT2[35] );
   FLIPFLOP U35_3 (RESULT2[35] , CLK , RESULT3[35] );
   assign RESULT[35] = RESULT3[35];
   FULL_ADDER U36_1 (RESULT3[36] , INT_CARRY[32] , INT_SUM[32] , S1[36] , C1[37] );
   CLRAND2 U36_2 (RESULT1[36] , CLR , RESULT2[36] );
   FLIPFLOP U36_3 (RESULT2[36] , CLK , RESULT3[36] );
   assign RESULT[36] = RESULT3[36];
   FULL_ADDER U37_1 (RESULT3[37] , INT_CARRY[32] , INT_SUM[32] , S1[37] , C1[38] );
   CLRAND2 U37_2 (RESULT1[37] , CLR , RESULT2[37] );
   FLIPFLOP U37_3 (RESULT2[37] , CLK , RESULT3[37] );
   assign RESULT[37] = RESULT3[37];
   FULL_ADDER U38_1 (RESULT3[38] , INT_CARRY[32] , INT_SUM[32] , S1[38] , C1[39] );
   CLRAND2 U38_2 (RESULT1[38] , CLR , RESULT2[38] );
   FLIPFLOP U38_3 (RESULT2[38] , CLK , RESULT3[38] );
   assign RESULT[38] = RESULT3[38];
   FULL_ADDER U39_1 (RESULT3[39] , INT_CARRY[32] , INT_SUM[32] , S1[39] , C1[40] );
   CLRAND2 U39_2 (RESULT1[39] , CLR , RESULT2[39] );
   FLIPFLOP U39_3 (RESULT2[39] , CLK , RESULT3[39] );
   assign RESULT[39] = RESULT3[39];
   FULL_ADDER U40_1 (RESULT3[40] , INT_CARRY[32] , INT_SUM[32] , S1[40] , C1[41] );
   CLRAND2 U40_2 (RESULT1[40] , CLR , RESULT2[40] );
   FLIPFLOP U40_3 (RESULT2[40] , CLK , RESULT3[40] );
   assign RESULT[40] = RESULT3[40];
   FULL_ADDER U41_1 (RESULT3[41] , INT_CARRY[32] , INT_SUM[32] , S1[41] , C1[42] );
   CLRAND2 U41_2 (RESULT1[41] , CLR , RESULT2[41] );
   FLIPFLOP U41_3 (RESULT2[41] , CLK , RESULT3[41] );
   assign RESULT[41] = RESULT3[41];
   FULL_ADDER U42_1 (RESULT3[42] , INT_CARRY[32] , INT_SUM[32] , S1[42] , C1[43] );
   CLRAND2 U42_2 (RESULT1[42] , CLR , RESULT2[42] );
   FLIPFLOP U42_3 (RESULT2[42] , CLK , RESULT3[42] );
   assign RESULT[42] = RESULT3[42];
   FULL_ADDER U43_1 (RESULT3[43] , INT_CARRY[32] , INT_SUM[32] , S1[43] , C1[44] );
   CLRAND2 U43_2 (RESULT1[43] , CLR , RESULT2[43] );
   FLIPFLOP U43_3 (RESULT2[43] , CLK , RESULT3[43] );
   assign RESULT[43] = RESULT3[43];
   FULL_ADDER U44_1 (RESULT3[44] , INT_CARRY[32] , INT_SUM[32] , S1[44] , C1[45] );
   CLRAND2 U44_2 (RESULT1[44] , CLR , RESULT2[44] );
   FLIPFLOP U44_3 (RESULT2[44] , CLK , RESULT3[44] );
   assign RESULT[44] = RESULT3[44];
   FULL_ADDER U45_1 (RESULT3[45] , INT_CARRY[32] , INT_SUM[32] , S1[45] , C1[46] );
   CLRAND2 U45_2 (RESULT1[45] , CLR , RESULT2[45] );
   FLIPFLOP U45_3 (RESULT2[45] , CLK , RESULT3[45] );
   assign RESULT[45] = RESULT3[45];
   FULL_ADDER U46_1 (RESULT3[46] , INT_CARRY[32] , INT_SUM[32] , S1[46] , C1[47] );
   CLRAND2 U46_2 (RESULT1[46] , CLR , RESULT2[46] );
   FLIPFLOP U46_3 (RESULT2[46] , CLK , RESULT3[46] );
   assign RESULT[46] = RESULT3[46];
   FULL_ADDER U47_1 (RESULT3[47] , INT_CARRY[32] , INT_SUM[32] , S1[47] , C1[48] );
   CLRAND2 U47_2 (RESULT1[47] , CLR , RESULT2[47] );
   FLIPFLOP U47_3 (RESULT2[47] , CLK , RESULT3[47] );
   assign RESULT[47] = RESULT3[47];
   FULL_ADDER U48_1 (RESULT3[48] , INT_CARRY[32] , INT_SUM[32] , S1[48] , C1[49] );
   CLRAND2 U48_2 (RESULT1[48] , CLR , RESULT2[48] );
   FLIPFLOP U48_3 (RESULT2[48] , CLK , RESULT3[48] );
   assign RESULT[48] = RESULT3[48];
   FULL_ADDER U49_1 (RESULT3[49] , INT_CARRY[32] , INT_SUM[32] , S1[49] , C1[50] );
   CLRAND2 U49_2 (RESULT1[49] , CLR , RESULT2[49] );
   FLIPFLOP U49_3 (RESULT2[49] , CLK , RESULT3[49] );
   assign RESULT[49] = RESULT3[49];
   FULL_ADDER U50_1 (RESULT3[50] , INT_CARRY[32] , INT_SUM[32] , S1[50] , C1[51] );
   CLRAND2 U50_2 (RESULT1[50] , CLR , RESULT2[50] );
   FLIPFLOP U50_3 (RESULT2[50] , CLK , RESULT3[50] );
   assign RESULT[50] = RESULT3[50];
   FULL_ADDER U51_1 (RESULT3[51] , INT_CARRY[32] , INT_SUM[32] , S1[51] , C1[52] );
   CLRAND2 U51_2 (RESULT1[51] , CLR , RESULT2[51] );
   FLIPFLOP U51_3 (RESULT2[51] , CLK , RESULT3[51] );
   assign RESULT[51] = RESULT3[51];
   FULL_ADDER U52_1 (RESULT3[52] , INT_CARRY[32] , INT_SUM[32] , S1[52] , C1[53] );
   CLRAND2 U52_2 (RESULT1[52] , CLR , RESULT2[52] );
   FLIPFLOP U52_3 (RESULT2[52] , CLK , RESULT3[52] );
   assign RESULT[52] = RESULT3[52];
   FULL_ADDER U53_1 (RESULT3[53] , INT_CARRY[32] , INT_SUM[32] , S1[53] , C1[54] );
   CLRAND2 U53_2 (RESULT1[53] , CLR , RESULT2[53] );
   FLIPFLOP U53_3 (RESULT2[53] , CLK , RESULT3[53] );
   assign RESULT[53] = RESULT3[53];
   FULL_ADDER U54_1 (RESULT3[54] , INT_CARRY[32] , INT_SUM[32] , S1[54] , C1[55] );
   CLRAND2 U54_2 (RESULT1[54] , CLR , RESULT2[54] );
   FLIPFLOP U54_3 (RESULT2[54] , CLK , RESULT3[54] );
   assign RESULT[54] = RESULT3[54];
   FULL_ADDER U55_1 (RESULT3[55] , INT_CARRY[32] , INT_SUM[32] , S1[55] , C1[56] );
   CLRAND2 U55_2 (RESULT1[55] , CLR , RESULT2[55] );
   FLIPFLOP U55_3 (RESULT2[55] , CLK , RESULT3[55] );
   assign RESULT[55] = RESULT3[55];
   FULL_ADDER U56_1 (RESULT3[56] , INT_CARRY[32] , INT_SUM[32] , S1[56] , C1[57] );
   CLRAND2 U56_2 (RESULT1[56] , CLR , RESULT2[56] );
   FLIPFLOP U56_3 (RESULT2[56] , CLK , RESULT3[56] );
   assign RESULT[56] = RESULT3[56];
   FULL_ADDER U57_1 (RESULT3[57] , INT_CARRY[32] , INT_SUM[32] , S1[57] , C1[58] );
   CLRAND2 U57_2 (RESULT1[57] , CLR , RESULT2[57] );
   FLIPFLOP U57_3 (RESULT2[57] , CLK , RESULT3[57] );
   assign RESULT[57] = RESULT3[57];
   FULL_ADDER U58_1 (RESULT3[58] , INT_CARRY[32] , INT_SUM[32] , S1[58] , C1[59] );
   CLRAND2 U58_2 (RESULT1[58] , CLR , RESULT2[58] );
   FLIPFLOP U58_3 (RESULT2[58] , CLK , RESULT3[58] );
   assign RESULT[58] = RESULT3[58];
   FULL_ADDER U59_1 (RESULT3[59] , INT_CARRY[32] , INT_SUM[32] , S1[59] , C1[60] );
   CLRAND2 U59_2 (RESULT1[59] , CLR , RESULT2[59] );
   FLIPFLOP U59_3 (RESULT2[59] , CLK , RESULT3[59] );
   assign RESULT[59] = RESULT3[59];
   FULL_ADDER U60_1 (RESULT3[60] , INT_CARRY[32] , INT_SUM[32] , S1[60] , C1[61] );
   CLRAND2 U60_2 (RESULT1[60] , CLR , RESULT2[60] );
   FLIPFLOP U60_3 (RESULT2[60] , CLK , RESULT3[60] );
   assign RESULT[60] = RESULT3[60];
   FULL_ADDER U61_1 (RESULT3[61] , INT_CARRY[32] , INT_SUM[32] , S1[61] , C1[62] );
   CLRAND2 U61_2 (RESULT1[61] , CLR , RESULT2[61] );
   FLIPFLOP U61_3 (RESULT2[61] , CLK , RESULT3[61] );
   assign RESULT[61] = RESULT3[61];
   FULL_ADDER U62_1 (RESULT3[62] , INT_CARRY[32] , INT_SUM[32] , S1[62] , C1[63] );
   CLRAND2 U62_2 (RESULT1[62] , CLR , RESULT2[62] );
   FLIPFLOP U62_3 (RESULT2[62] , CLK , RESULT3[62] );
   assign RESULT[62] = RESULT3[62];
   FULL_ADDER U63_1 (RESULT3[63] , INT_CARRY[32] , INT_SUM[32] , S1[63] , C1[64] );
   CLRAND2 U63_2 (RESULT1[63] , CLR , RESULT2[63] );
   FLIPFLOP U63_3 (RESULT2[63] , CLK , RESULT3[63] );
   assign RESULT[63] = RESULT3[63];
endmodule


module CLRAND2 ( A, B, Q );
input  A;
input  B;
output Q;
   assign Q = A & ( ~ B);
endmodule


module INVBLOCK ( GIN, PHI, GOUT );
input  GIN;
input  PHI;
output GOUT;
   assign GOUT =  ~ GIN;
endmodule


module XXOR1 ( A, B, GIN, PHI, SUM );
input  A;
input  B;
input  GIN;
input  PHI;
output SUM;
   assign SUM = ( ~ (A ^ B)) ^ GIN;
endmodule


module BLOCK0 ( A, B, PHI, POUT, GOUT );
input  A;
input  B;
input  PHI;
output POUT;
output GOUT;
   assign POUT =  ~ (A | B);
   assign GOUT =  ~ (A & B);
endmodule


module BLOCK1 ( PIN1, PIN2, GIN1, GIN2, PHI, POUT, GOUT );
input  PIN1;
input  PIN2;
input  GIN1;
input  GIN2;
input  PHI;
output POUT;
output GOUT;
   assign POUT =  ~ (PIN1 | PIN2);
   assign GOUT =  ~ (GIN2 & (PIN2 | GIN1));
endmodule


module BLOCK2 ( PIN1, PIN2, GIN1, GIN2, PHI, POUT, GOUT );
input  PIN1;
input  PIN2;
input  GIN1;
input  GIN2;
input  PHI;
output POUT;
output GOUT;
   assign POUT =  ~ (PIN1 & PIN2);
   assign GOUT =  ~ (GIN2 | (PIN2 & GIN1));
endmodule


module BLOCK1A ( PIN2, GIN1, GIN2, PHI, GOUT );
input  PIN2;
input  GIN1;
input  GIN2;
input  PHI;
output GOUT;
   assign GOUT =  ~ (GIN2 & (PIN2 | GIN1));
endmodule


module BLOCK2A ( PIN2, GIN1, GIN2, PHI, GOUT );
input  PIN2;
input  GIN1;
input  GIN2;
input  PHI;
output GOUT;
   assign GOUT =  ~ (GIN2 | (PIN2 & GIN1));
endmodule


module PRESTAGE_64 ( A, B, CIN, PHI, POUT, GOUT );
input  [0:63] A;
input  [0:63] B;
input  CIN;
input  PHI;
output [0:63] POUT;
output [0:64] GOUT;
   for U1 (A , B , PHI , POUT , GOUT );
endmodule


module ADDER_OUTBUF_64 ( SUM_IN, COUT_IN, CLK, SUM_OUT, COUT_OUT );
input  [0:63] SUM_IN;
input  COUT_IN;
input  CLK;
output [0:63] SUM_OUT;
output COUT_OUT;
   reg [0:63] SUM_OUT_reg;
   reg COUT_OUT_reg;
   always @ ( posedge CLK ) begin
      SUM_OUT_reg[0:63] = SUM_IN[0:63];
      COUT_OUT_reg = COUT_IN;
   end
   assign SUM_OUT[0:63] = SUM_OUT_reg[0:63];
   assign COUT_OUT = COUT_OUT_reg;
endmodule


module DBLC_0_64 ( PIN, GIN, PHI, POUT, GOUT );
input  [0:63] PIN;
input  [0:64] GIN;
input  PHI;
output [0:62] POUT;
output [0:64] GOUT;
   for U1 (GIN , PHI , GOUT );
endmodule


module DBLC_1_64 ( PIN, GIN, PHI, POUT, GOUT );
input  [0:62] PIN;
input  [0:64] GIN;
input  PHI;
output [0:60] POUT;
output [0:64] GOUT;
   for U1 (GIN , PHI , GOUT );
endmodule


module DBLC_2_64 ( PIN, GIN, PHI, POUT, GOUT );
input  [0:60] PIN;
input  [0:64] GIN;
input  PHI;
output [0:56] POUT;
output [0:64] GOUT;
   for U1 (GIN , PHI , GOUT );
endmodule


module DBLC_3_64 ( PIN, GIN, PHI, POUT, GOUT );
input  [0:56] PIN;
input  [0:64] GIN;
input  PHI;
output [0:48] POUT;
output [0:64] GOUT;
   for U1 (GIN , PHI , GOUT );
endmodule


module DBLC_4_64 ( PIN, GIN, PHI, POUT, GOUT );
input  [0:48] PIN;
input  [0:64] GIN;
input  PHI;
output [0:32] POUT;
output [0:64] GOUT;
   for U1 (GIN , PHI , GOUT );
endmodule


module DBLC_5_64 ( PIN, GIN, PHI, POUT, GOUT );
input  [0:32] PIN;
input  [0:64] GIN;
input  PHI;
output [0:0] POUT;
output [0:64] GOUT;
   for U1 (GIN , PHI , GOUT );
endmodule


module XORSTAGE_64 ( A, B, PBIT, PHI, CARRY, SUM, COUT );
input  [0:63] A;
input  [0:63] B;
input  PBIT;
input  PHI;
input  [0:64] CARRY;
output [0:63] SUM;
output COUT;
   for U2 (A , B , CARRY , PHI , SUM );
endmodule


module DBLCTREE_64 ( PIN, GIN, PHI, GOUT, POUT );
input  [0:63] PIN;
input  [0:64] GIN;
input  PHI;
output [0:64] GOUT;
output [0:0] POUT;
   wire [0:62] INTPROP_0;
   wire [0:64] INTGEN_0;
   wire [0:60] INTPROP_1;
   wire [0:64] INTGEN_1;
   wire [0:56] INTPROP_2;
   wire [0:64] INTGEN_2;
   wire [0:48] INTPROP_3;
   wire [0:64] INTGEN_3;
   wire [0:32] INTPROP_4;
   wire [0:64] INTGEN_4;
   DBLC_0_64 U_0 (.PIN(PIN) , .GIN(GIN) , .PHI(PHI) , .POUT(INTPROP_0) , .GOUT(INTGEN_0) );
   DBLC_1_64 U_1 (.PIN(INTPROP_0) , .GIN(INTGEN_0) , .PHI(PHI) , .POUT(INTPROP_1) , .GOUT(INTGEN_1) );
   DBLC_2_64 U_2 (.PIN(INTPROP_1) , .GIN(INTGEN_1) , .PHI(PHI) , .POUT(INTPROP_2) , .GOUT(INTGEN_2) );
   DBLC_3_64 U_3 (.PIN(INTPROP_2) , .GIN(INTGEN_2) , .PHI(PHI) , .POUT(INTPROP_3) , .GOUT(INTGEN_3) );
   DBLC_4_64 U_4 (.PIN(INTPROP_3) , .GIN(INTGEN_3) , .PHI(PHI) , .POUT(INTPROP_4) , .GOUT(INTGEN_4) );
   DBLC_5_64 U_5 (.PIN(INTPROP_4) , .GIN(INTGEN_4) , .PHI(PHI) , .POUT(POUT) , .GOUT(GOUT) );
endmodule


module DBLCADDER_64_64 ( OPA, OPB, CIN, CLK, PHI, SUM, COUT );
input  [0:63] OPA;
input  [0:63] OPB;
input  CIN;
input  CLK;
input  PHI;
output [0:63] SUM;
output COUT;
   wire [0:63] INTPROP;
   wire [0:64] INTGEN;
   wire [0:0] PBIT;
   wire [0:64] CARRY;
   wire INT_COUT;
   wire [0:63] INT_SUM;
   PRESTAGE_64 U1 (OPA , OPB , CIN , PHI , INTPROP , INTGEN );
   DBLCTREE_64 U2 (INTPROP , INTGEN , PHI , CARRY , PBIT );
   XORSTAGE_64 U3 (OPA[0:63] , OPB[0:63] , PBIT[0] , PHI , CARRY[0:64] , INT_SUM , INT_COUT );
   ADDER_OUTBUF_64 U4 (INT_SUM , INT_COUT , CLK , SUM , COUT );
endmodule


