//////////////////////////////////////////////////////////////////////
////                                                              ////
////  OR1200's simulation monitor (stub)                          ////
////                                                              ////
////  This file is part of the OpenRISC 1200 project              ////
////  http://www.opencores.org/cores/or1k/                        ////
////                                                              ////
////  Description                                                 ////
////  Simulation monitor                                          ////
////                                                              ////
////  To Do:                                                      ////
////   - move it to bench                                         ////
////                                                              ////
////  Author(s):                                                  ////
////      - Damjan Lampret, lampret@opencores.org                 ////
////                                                              ////
//////////////////////////////////////////////////////////////////////
////                                                              ////
//// Copyright (C) 2000 Authors and OPENCORES.ORG                 ////
////                                                              ////
//// This source file may be used and distributed without         ////
//// restriction provided that this copyright statement is not    ////
//// removed from the file and that any derivative work contains  ////
//// the original copyright notice and the associated disclaimer. ////
////                                                              ////
//// This source file is free software; you can redistribute it   ////
//// and/or modify it under the terms of the GNU Lesser General   ////
//// Public License as published by the Free Software Foundation; ////
//// either version 2.1 of the License, or (at your option) any   ////
//// later version.                                               ////
////                                                              ////
//// This source is distributed in the hope that it will be       ////
//// useful, but WITHOUT ANY WARRANTY; without even the implied   ////
//// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR      ////
//// PURPOSE.  See the GNU Lesser General Public License for more ////
//// details.                                                     ////
////                                                              ////
//// You should have received a copy of the GNU Lesser General    ////
//// Public License along with this source; if not, download it   ////
//// from http://www.opencores.org/lgpl.shtml                     ////
////                                                              ////
//////////////////////////////////////////////////////////////////////
//
// CVS Revision History
//
// $Log$
//


// Enable debug_mem task. Only affects simulation.
`define enable_debug_mem

// Enable display_arch_state task. Only affects simulation.
`define enable_display_arch_state

task monitortask;
begin
	$display("");
end
endtask

task finish_simulation;
begin
	$finish;
end
endtask
	
task caught_sys203;
begin
	$display("simulation terminated due to l.sys 203");
end
endtask

task display_arch_state;
reg [5:0] i;
begin
`ifdef enable_display_arch_state
	$display;
`endif
end
endtask

task display_memory;
input [31:0] from;
input [31:0] to;
integer i;
begin
	$display;
end
endtask

task debug_mem;
input [79:0] device;
input write;
input [31:0] addr;
input [31:0] data;
input [3:0] bs;
begin
	$display;
end
endtask
